package edu.mit.csail.aeolus.apps.TestServer;

import edu.mit.csail.aeolus.api.*;

public class TestServerClient {

        public static void main(String[] args) throws Exception {
		String ans_str = "";
                System.out.println("Hello from TestServerClient!");

		TestServerInterface stub = (TestServerInterface) AeolusLib.getService("anar.csail.mit.edu",
			"TestServer", TestServerInterface.class);

                PID mypid = AeolusLib.getPID();
                PID x = new PID();
		PID y = new PID();
		x.actFor(y);

		{
                AeolusTag s = new AeolusTag();
		AeolusTag t = new AeolusTag(s);		// t is subtag of s

		boolean isSubT = s.isSubTag(t);
		if (isSubT) System.out.println("s is subTag of t");
		else System.out.println("s is not subTag of t");

		isSubT = t.isSubTag(s);
		if (isSubT) System.out.println("t is subTag of s");
		else System.out.println("t is not subTag of s");

		boolean isSupT = s.isSuperTag(t);
		if (isSupT) System.out.println("s is superTag of t");
		else System.out.println("s is not superTag of t");

		isSupT = t.isSuperTag(s);
		if (isSupT) System.out.println("t is superTag of s");
		else System.out.println("t is not superTag of s");
		}


                AeolusTag t = new AeolusTag();
                t.delegate(mypid, x);
                boolean has = t.hasAuthority(y);
		if (has) System.out.println("y " + y + " has authority for t");
		else System.out.println("y " + y + " does NOT have authority for t");

                has = t.hasAuthority(x);
		if (has) System.out.println("x " + x + " has authority for t");
		else System.out.println("x " + x + " does NOT have authority for t");

                has = t.hasAuthority();
		if (has) System.out.println("self " + mypid + " has authority for t");
		else System.out.println("self " + mypid + " does NOT have authority for t");

		boolean acts = x.doesActFor(y);
		if (acts) { System.out.println("x acts for y"); }
		else { System.out.println("x does NOT act for y"); }

		acts = y.doesActFor(x);
		if (acts) { System.out.println("y acts for x"); }
		else { System.out.println("y does NOT act for x"); }

		acts = x.doesActFor(mypid);
		if (acts) { System.out.println("x acts for mypid"); }
		else { System.out.println("x does NOT act for mypid"); }

		acts = y.doesActFor(mypid);
		if (acts) { System.out.println("y acts for mypid"); }
		else { System.out.println("y does NOT act for mypid"); }

		acts = mypid.doesActFor(x);
		if (acts) { System.out.println("mypid acts for x"); }
		else { System.out.println("mypid does NOT act for x"); }

		acts = mypid.doesActFor(y);
		if (acts) { System.out.println("mypid acts for y"); }
		else { System.out.println("mypid does NOT act for y"); }

		// System.exit(0);

                ans_str = stub.tagTest(t, x);
                System.out.println("ZZZZZ " + ans_str);

		t.revoke(mypid, x);
                has = t.hasAuthority(x);
		if (has) System.out.println("x has authority for t");
		else System.out.println("x does NOT have authority for t");

                ans_str = stub.tagTest(t, x);
                System.out.println("ZZZZZ " + ans_str);

		y.revoke(x);
		acts = x.doesActFor(y);
		if (acts) { System.out.println("x acts for y"); }
		else { System.out.println("x does NOT act for y"); }
		
		acts = y.doesActFor(x);
		if (acts) { System.out.println("y acts for x"); }
		else { System.out.println("y does NOT act for x"); }

		AeolusLabel mySLabel = AeolusLib.getSecrecy();
		System.out.println("mySLabel = " + mySLabel);
		// AeolusLib.registerService("TestServer", TestServer.class);
		try {
			Integer ans = stub.addHandler(1, 3);
			System.out.println("ZZZZZ " + ans);
		} catch (Exception e) {
			System.out.println("ZZZZ Exception " + e.getCause() + " " + e.getMessage());
		}
		mySLabel = AeolusLib.getSecrecy();
		System.out.println("mySLabel = " + mySLabel);
		ans_str = stub.concatHandler("asdf", "jkl;");
		System.out.println("ZZZZZ " + ans_str);
		mySLabel = AeolusLib.getSecrecy();
		System.out.println("mySLabel = " + mySLabel);

		ans_str = stub.showPIDandBasis();
		System.out.println("PID and Basis " + ans_str);

        }
}
