package edu.mit.csail.aeolus.apps.medical;

import edu.mit.csail.aeolus.exceptions.*;
// import edu.mit.csail.aeolus.runtime3.*;
// import edu.mit.csail.aeolus.infoflow3.*;
import edu.mit.csail.aeolus.api.*;

import java.util.HashMap;
import java.util.Map;

// import edu.mit.csail.aeolus.api3.PID;

public class MedicalState {
	Map<String, Object> patToSharedObjectMap;
	Map<String, AeolusTag> patToMedicalTagMap;
	Map<String, PID> docToPrincipalMap;
	AeolusTag adminTag;
	PID adminGeneric;

	public void setupServer(PID root) throws AuthorityException, AeolusException{
		System.out.println("root" + root);
		System.out.println("getPID");
		adminGeneric = AeolusLib.getPID();	// seems like this should be a new PID, not "me"
		System.out.println("AeolusTag");
		adminTag = new AeolusTag();
	
		System.out.println("setupServer: adminTag delegate root to adminGeneric");	
		adminTag.delegate(root, adminGeneric);
		
		patToMedicalTagMap = new HashMap<String, AeolusTag>();
		patToSharedObjectMap = new HashMap<String, Object>();
		docToPrincipalMap = new HashMap<String, PID>();
	}
	
	// Run AS administratorGeneric
	public void createPatient(String patient) 
	throws InfoFlowControlException, AeolusException{
	
		// TODO really should be a shared state MAP for these tags / object integers.
	
		System.out.println("createPatient " + patient);	
		AeolusLib.endorse(adminTag);
		
		AeolusTag userMedicalTag = new AeolusTag();
		patToMedicalTagMap.put(patient, userMedicalTag);
		
		AeolusLib.addSecrecy(userMedicalTag);
		AeolusLib.endorse(userMedicalTag);
		// TODO ss
//		Integer objId = u.createSharedObject(new Label(userMedicalTag),new Label(userMedicalTag), "" );
		patToSharedObjectMap.put(patient, null);
		
		AeolusLib.removeIntegrity(userMedicalTag);
		AeolusLib.declassify(userMedicalTag);
		
		AeolusLib.removeIntegrity(adminTag);
	}
	
	public void createDoctor(String doctorName) throws AuthorityException, AeolusException{
		System.out.println("createDoctor " + doctorName);	
		AeolusLib.endorse(adminTag);
		
		PID doctorP = new PID();
		docToPrincipalMap.put(doctorName, doctorP);
			
		AeolusLib.removeIntegrity(adminTag);
	}
	
	public void setCurrentDoctor(String doctorName, String patientName, PID currentAdmin) 
	throws AuthorityException, AeolusException{
		AeolusTag tPat = patToMedicalTagMap.get(patientName);
		PID pDoc = docToPrincipalMap.get(doctorName);
		System.out.println("setCurrentDoctor: tPat " + tPat + " delegate currentAdmin "
			+ currentAdmin + " to pDoc " + pDoc);	
		tPat.delegate(currentAdmin, pDoc);
	}
	
	public void revokeCurrentDoctor(String doctorName, String patientName, PID currentAdmin) 
	throws AuthorityException, AeolusException{
		AeolusTag tPat = patToMedicalTagMap.get(patientName);
		PID pDoc = docToPrincipalMap.get(doctorName);
		tPat.revoke(currentAdmin, pDoc);
	}
	
	@SuppressWarnings("serial")
    	public void appendPatientInfoAs(final String patientName, final String toAppend,
    			final String asDoctor) throws AuthorityException, Exception {
    		final PID pDoc = docToPrincipalMap.get(asDoctor);
    		final Object obj = patToSharedObjectMap.get(patientName);
    		final AeolusTag tPat = patToMedicalTagMap.get(patientName);
//    		AeolusCallable c = new AeolusCallable() {
//    			public void invoke() throws Exception {
//    				for(int i = 0; i < 10000; i++){
//    				adminGeneric.addSecrecy(tPat);
//    				// TODO ss
//    //				String curRecord = (String) u.getSharedObject(objID);
//    //				String newRecord = curRecord + "\n" + toAppend;
//    				AeolusLib.endorse(tPat);
//    //				u.replaceSharedObject(objID, newRecord);
//    				AeolusLib.removeIntegrity(tPat);
//    				AeolusLib.declassify(tPat);
//    				}
//    			}
//    		};
//    		
//    		call(c, pDoc);
    	}
	
}
