package edu.mit.csail.aeolus.apps.mint1;

import java.text.*;
import java.util.*;
import java.io.Serializable;
import java.util.concurrent.Callable;
// import edu.mit.csail.aeolus.infoflow.PrincipalID;
// import edu.mit.csail.aeolus.infoflow.TagID;
// import edu.mit.csail.aeolus.infoflow.ClosureID;
// import edu.mit.csail.aeolus.exceptions.AuthorityException;
// import edu.mit.csail.aeolus.api.AeolusUser;
// import edu.mit.csail.aeolus.api.AeolusCallable;
import edu.mit.csail.aeolus.api.*;
import edu.mit.csail.aeolus.exceptions.*;

public class Customer implements Serializable {
	private final long serialVersionUID = 1L;
	private PID pid;
	private AeolusTag CustomerTag;
	private Callable<Integer> closure;
	private Callable<Integer> closure_code;
	private int acct_number;
	private String acct_str;
	private String dirname;
	private Vector<BankInfo> BankAccts = new Vector<BankInfo>(10);
	private Vector<Bank> Banks;
	private boolean simple = false;
	private Credentials fake_credentials;
	public String name;
	public Customer(int number, Vector<Bank> Banks, AeolusTag ctag, PID cpid, int work_time)
			throws AuthorityException, AeolusException {
		if (cpid == null) pid = new PID();
		else pid = cpid;
		if (ctag == null) CustomerTag = new AeolusTag();
		else CustomerTag = ctag;		// XXX hack to make all companies have the same tag
		CustomerTag.delegate(AeolusLib.getPID(), pid);

		this.acct_number = number;
		DecimalFormat f = new DecimalFormat("000000");
		this.acct_str = f.format(number);
		this.dirname = acct_str.charAt(0) + "/" + acct_str.charAt(1) + "/" + acct_str.charAt(2) +
			acct_str.substring(4);
		this.name = 'C' + acct_str;
		// String fname = dirname + "/" + bankname; // could get this info out of files
		this.Banks = Banks;
		int i = 0;
		for (Bank b: Banks) {
			String bank_name = b.getName();
			AeolusTag bank_tag = b.getTag();
			String login_name = this.name;
			String password = this.name + "123" + i;
			Credentials bank_creds = new Credentials(bank_name, bank_tag, ctag, login_name, password);
			BankAccts.add(new BankInfo(bank_name, bank_creds, work_time));
			i++;
		}

                closure_code = new Callable<Integer>() {
                       private final long serialVersionUID = 1L;
                       public Integer call() throws Exception {
				return new Integer(22);
                       }
                };
	}

	public Customer(int number, Vector<Bank> Banks, AeolusTag all_cust_tag, int work_time)
			throws AuthorityException, AeolusException {
		pid = new PID();
		CustomerTag = new AeolusTag(all_cust_tag);
		CustomerTag.delegate(AeolusLib.getPID(), pid);

		if (simple != true) {
		this.acct_number = number;
		DecimalFormat f = new DecimalFormat("000000");
		this.acct_str = f.format(number);
		this.dirname = acct_str.charAt(0) + "/" + acct_str.charAt(1) + "/" + acct_str.charAt(2) +
			acct_str.substring(4);
		this.name = 'C' + acct_str;
		}
		// String fname = dirname + "/" + bankname; // could get this info out of files
		this.Banks = Banks;
		int i = 0;
		// System.out.println("Cust 3");
		for (Bank b: Banks) {
			String bank_name = b.getName();
			AeolusTag bank_tag = b.getTag();
			String login_name = this.name;
			String password = this.name + "123" + i;
			Credentials bank_creds = new Credentials(bank_name, bank_tag, CustomerTag, login_name, password);
			BankAccts.add(new BankInfo(bank_name, bank_creds, work_time));
			i++;
		}
		// System.out.println("Cust 4");

                closure_code = new Callable<Integer>() {
                       private final long serialVersionUID = 1L;
                       public Integer call() throws Exception {
				return new Integer(22);
                       }
                };
	}
	public PID getPID() {
	 	return pid;
	}
        public AeolusTag getTag() {
                return CustomerTag;
        }
	public String getName() {
	 	return name;
	}
	public Credentials getCredentials(String bankname) throws NoCredentialsException {
		if (simple == true) return fake_credentials;
		else {
		for (BankInfo b : BankAccts) {
			if (b.bank_name.equals(bankname)) return b.getCredentials();
		}
		throw new NoCredentialsException();
		}
	}
	public Callable<Integer> getCustomerClosure() {
		return closure;
	}
	public Callable<Integer> getCustomerClosureCode() {
		return closure_code;
	}

	public Callable<Integer> evaluator = new Callable<Integer>()
	{
	    final long serialVersionUID = 1L;
	    public Integer call() throws AeolusException {
		// System.out.println(name + " evaluator ");
		// System.out.println("Resume " + currentResume);
		return new Integer(22);
	    }
	};
	

	public class CC implements Callable<Integer> {
               final long serialVersionUID = 1L;

                public CC(int run)
                {

                }

                public Integer call() throws Exception
                {
                     System.out.println("AAAA");
                     return new Integer(5);
                }
        }
	public void updateRecentTransactions(String bankname, Vector<Transaction> transactions) {
		// String fname = dirname + "/" + bankname;
		// open file and write transactions to it (no append: just wipe and write and truncate)
		for (BankInfo b : BankAccts) {
			if (b.bank_name.equals(bankname)) b.updateRecentTransactions(transactions);
		}
	}
	public Vector<Transaction> getRecentTransactions(String bankname) {
		for (BankInfo b : BankAccts) {
			if (b.bank_name.equals(bankname)) return b.getRecentTransactions();
		}
		return null;
	}
}
