package edu.mit.csail.aeolus.apps.mint3;

import java.io.Serializable;

import edu.mit.csail.aeolus.api.AeolusLabel;
import edu.mit.csail.aeolus.api.AeolusLib;
import edu.mit.csail.aeolus.api.AeolusShared;
import edu.mit.csail.aeolus.api.AeolusTag;
import edu.mit.csail.aeolus.api.PID;
import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.exceptions.InfoFlowControlException;

public class Bank extends AeolusShared implements MintObject, Serializable, MintPrincipal{

	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	

	private String bankName;
	private PID bankPID;
	private AeolusTag bankTag;

	public Bank(String bankName, AeolusTag bankTag) throws InfoFlowControlException {
		super(new AeolusLabel(), Utils.createLabel(bankTag));
		this.bankName = bankName;
		try {
			this.bankTag = bankTag;
			bankPID = new PID();
			AeolusLib.getPID().actFor(bankPID);
			this.bankTag.delegate(AeolusLib.getPID(), bankPID);
		} catch (InfoFlowControlException e) {
			e.printStackTrace();
		} catch (AuthorityException e) {
			e.printStackTrace();
		} catch (AeolusException e) {
			e.printStackTrace();
		}
//		checkrep();
	}
	
	private void checkrep() {
//		System.out.println(bankTag.hasAuthority(bankPID));
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) return true;
		if (!(obj instanceof Bank)) return false;
		Bank bank = (Bank) obj;
		return bank.getBankName().equals(bankName);
	}

	@Override
	public int hashCode() {
		return bankName.hashCode();
	}
	@Override
	public String toString() {
		StringBuffer print = new StringBuffer();
		print.append("Bank\n  ");
		print.append("Bank name: ");
		print.append(bankName);
		print.append("\n  ");
		print.append("PID: ");
		print.append(bankPID);
		print.append("\n  ");
		print.append("tag: ");
		print.append(bankTag);
		return print.toString();
	}
	public String getBankName() {
		return bankName;
	}

	public AeolusTag getBankTag() {
		return bankTag;
	}
	
	public PID getBankPID() {
		return bankPID;
	}

	@Override
	public String getFileName() {
		return bankName;
	}
}
