package edu.mit.csail.aeolus.apps.mint3;

import java.io.Serializable;

import edu.mit.csail.aeolus.api.AeolusClosure;
import edu.mit.csail.aeolus.api.AeolusLib;
import edu.mit.csail.aeolus.api.AeolusTag;
import edu.mit.csail.aeolus.api.PID;
import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.exceptions.AuthorityException;

public class BankClosure extends AeolusClosure implements Serializable{

	protected BankClosure(PID pid) throws AuthorityException {
		super(pid);
	}
	
	public boolean authCustomer(BankCredentialsWrapper creds) throws AeolusException{
		AeolusTag bankTag = creds.getBankTag();
		AeolusLib.addSecrecy(bankTag);
		// TODO authenticate client
		AeolusLib.declassify(bankTag);
		return true;
	}
	@Override
	public String toString() {
		StringBuffer print = new StringBuffer();
		print.append("BankClosure\n  ");
		print.append("PID: ");
		print.append(getPID());
		return print.toString();
	}
}
