package edu.mit.csail.aeolus.apps.mint3;

import java.io.Serializable;

import edu.mit.csail.aeolus.api.AeolusShared;
import edu.mit.csail.aeolus.api.AeolusTag;
import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.exceptions.InfoFlowControlException;

public class BankCredentialsWrapper extends AeolusShared implements MintObject,
		Serializable {

	/**
	 * This class has to be immutable.
	 * 
	 * 
	 */
	private static final long serialVersionUID = 1L;

	private String cus;
	private String bank;
	private BankCredentials creds;
	private AeolusTag uTag;
	private AeolusTag bTag;

	public BankCredentialsWrapper(String username, String bankName, AeolusTag userTag,
			AeolusTag bankTag, String bankUsername, String bankPassword)
			throws InfoFlowControlException {
		super(Utils.createLabel(userTag), Utils
				.createLabel(userTag));
		this.cus = username;
		uTag = userTag;
		this.bank = bankName;
		bTag = bankTag;
		this.creds = new BankCredentials(Utils.createLabel(userTag, bankTag), Utils
				.createLabel(userTag), bankUsername, bankPassword);
	}

	public static String createBankCredsFileName(String userFileName,
			String bankFileName) {
		return userFileName + "/" + bankFileName + "-bankcredentials";
	}

	public String getCustomerName() {
		return cus;
	}

	public String getBankName() {
		return bank;
	}

	public AeolusTag getUserDataTag() {
		return uTag;
	}

	public AeolusTag getBankTag() {
		return bTag;
	}

	@Override
	public String getFileName() {
		return cus + "/" + bank + "-bankcredentials";
	}

	public BankCredentials getCreds() {
		return creds;
	}

}
