package edu.mit.csail.aeolus.apps.mint3;

import java.io.ByteArrayInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.rmi.RemoteException;

import edu.mit.csail.aeolus.api.AeolusFileInputStream;
import edu.mit.csail.aeolus.api.AeolusTag;
import edu.mit.csail.aeolus.exceptions.AeolusException;

public class FSReaderVisitor {
	
	public FSReaderVisitor() {
		super();
	}
	
	public Bank visit(Bank bank){
		String path = MintConfig.banks + bank.getFileName();
		return (Bank) deserializeObjectFromFile(path);
	}
	
	public Customer visit(Customer cus){
		String path = MintConfig.customers + "/" + cus.getFileName();
		return (Customer) deserializeObjectFromFile(path);
	}
	
	private MintObject deserializeObjectFromFile(String path) {
		AeolusFileInputStream in;
		MintObject minto = null;
		try {
			in = new AeolusFileInputStream(MintConfig.host, path);
			byte[] buffer = new byte[1000];
			in.read(buffer);
			ObjectInputStream strm = new ObjectInputStream(new ByteArrayInputStream(buffer));
			minto = (MintObject) strm.readObject();
			strm.close();
			in.close();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			return null;
		} catch (AeolusException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return minto;
	}
}
