package edu.mit.csail.aeolus.apps.mint3;

import java.io.FileNotFoundException;
import java.io.IOException;

import edu.mit.csail.aeolus.api.AeolusFile;
import edu.mit.csail.aeolus.api.AeolusLabel;
import edu.mit.csail.aeolus.api.AeolusLib;
import edu.mit.csail.aeolus.api.AeolusTag;
import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.exceptions.InfoFlowControlException;

public class FSWriterVisitor {
	
	public FSWriterVisitor() {
		super();
	}

	
	public boolean visit(BankCredentialsWrapper bankCreds, AeolusTag userTag, AeolusTag bankTag){
		try {
			AeolusLib.addSecrecy(userTag);
			AeolusLib.endorse(userTag);
			String path = MintConfig.customers + "/" + bankCreds.getFileName();
			AeolusFile f = new AeolusFile(MintConfig.host, path);
			AeolusLabel sLabel = new AeolusLabel();
			AeolusLabel iLabel = new AeolusLabel();
			iLabel.addTag(userTag);
			sLabel.addTag(userTag);
			sLabel.addTag(bankTag);
			f.createNewFile(sLabel, iLabel);
			MintSerializer.serializeObjectToFile(path, bankCreds);
			return true;
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (InfoFlowControlException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (AeolusException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return false;
	}
	public boolean visit(Customer cus, AeolusTag userTag){
		try {
			AeolusLib.addSecrecy(userTag);
			AeolusLib.endorse(userTag);
			String path = MintConfig.customers + "/" + cus.getFileName() + "/data";
			AeolusLabel userLabel = new AeolusLabel();
			userLabel.addTag(userTag);
			AeolusFile f = new AeolusFile(MintConfig.host, path);
			f.createNewFile(userLabel, userLabel);
			MintSerializer.serializeObjectToFile(path, cus);
			AeolusLib.declassify((userTag));
			AeolusLib.removeIntegrity(userTag);
			return true;
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (InfoFlowControlException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (AeolusException e) {
			e.printStackTrace();
		}
		return false;
	}
}
