package edu.mit.csail.aeolus.apps.mint3;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.rmi.RemoteException;

import edu.mit.csail.aeolus.api.AeolusFileInputStream;
import edu.mit.csail.aeolus.api.AeolusFileOutputStream;
import edu.mit.csail.aeolus.exceptions.AeolusException;

public class MintSerializer {
	public static MintObject deserializeObjectFromFile(String path) {
		AeolusFileInputStream in;
		MintObject minto = null;
		try {
			in = new AeolusFileInputStream(MintConfig.host, path);
			byte[] buffer = new byte[10000];
			in.read(buffer);
			ObjectInputStream strm = new ObjectInputStream(new ByteArrayInputStream(buffer));
			minto = (MintObject) strm.readObject();
			strm.close();
			in.close();
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			return null;
		} catch (AeolusException e) {
			e.printStackTrace();
		} catch (IOException e) {
			if(e instanceof FileNotFoundException)
				return null;
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return minto;
	}
	
	public static boolean serializeObjectToFile(String path, MintObject minto) {
		AeolusFileOutputStream out;
		try {
			out = new AeolusFileOutputStream(MintConfig.host, path, false);
			byte[] buffer = new byte[256];
			ByteArrayOutputStream bytestream = new ByteArrayOutputStream();
			ObjectOutputStream outstrm = new ObjectOutputStream(bytestream);
			outstrm.writeObject(minto);
			outstrm.flush();
			outstrm.close();
			buffer = bytestream.toByteArray();
			out.write(buffer);
			out.close();
			return true;
		} catch (RemoteException e) {
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (AeolusException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return false;
	}
}
