package edu.mit.csail.aeolus.apps.mint3;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.ArrayList;

import edu.mit.csail.aeolus.api.AeolusClosure;
import edu.mit.csail.aeolus.api.AeolusFile;
import edu.mit.csail.aeolus.api.AeolusLabel;
import edu.mit.csail.aeolus.api.AeolusLib;
import edu.mit.csail.aeolus.api.AeolusTag;
import edu.mit.csail.aeolus.api.PID;
import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.exceptions.InfoFlowControlException;

public class Test {

	public static void main(String[] args) throws Exception{
		boolean debug = true;
		if (debug) System.out.println("mint3: Entering Test");
		AeolusTag utag = new AeolusTag();
		AeolusTag btag = new AeolusTag();
//		readServerStateFromDisk(MintConfig.serverStatePath);
		MintServerState ms = new MintServerState(360*1000l, utag, btag);
		
		initFS(utag, btag);
		if (debug) System.out.println("mint3: Test: after ms construction ");
		// AeolusTag at = ms.getAllUserDataTag();
		if (debug) System.out.println("mint3: Test: after get tag");
		AeolusLib.setRoot(ms);
		if (debug) System.out.println("mint3: Test: after set root");

		if (debug) System.out.println("mint3: After setRoot");
		AeolusLib.registerService("UserActions", UserActions.class);
		if (debug) System.out.println("mint3: After registerService");
			
		InterfaceUserActions stub = (InterfaceUserActions) AeolusLib.getService("localhost", "UserActions", 
				InterfaceUserActions.class);
		if (debug) System.out.println("mint3: After getService");
		
		System.out.println("true: " + stub.userSignup("wissam", "jarjoui"));
		if (debug) System.out.println("mint3: After userSignup");
		System.out.println("true: " + stub.userAddBank("wissam", "Bank of America", "boawissam", "boajarjoui"));
		if (debug) System.out.println("mint3: After addBank 1");
		System.out.println("true: " + stub.userAddBank("wissam", "US Bank", "usbwissam", "usbjarjoui"));
		if (debug) System.out.println("mint3: After addBank 2");
		System.out.println("true: " + stub.userLogout("wissam")); //use session key here instead?
		if (debug) System.out.println("mint3: After userLogout");
		System.out.println("false: " + stub.userAddBank("wissam", "Bank United", "buwissam", "bujarjoui"));
		if (debug) System.out.println("mint3: After addBank 3");
//		System.out.println(stub.userCollectReport("wissam"));
		
		stub.userSignup("david", "secret");
		stub.userAddBank("david", "cool Bank", "das", "pmg");
		stub.userAddBank("david", "chair", "dchair", "whaat");
		stub.userCollectReport("david");
		
		stub.userSignup("dan", "secret");
		stub.userAddBank("dan", "cool Bank", "das", "pmg");
		stub.userAddBank("dan", "chair", "dchair", "whaat");
		stub.userCollectReport("dan");
		System.out.println(true);
		
		System.out.println("Attempting attack from david victim: dan");
		System.out.println("Dan's password: " + stub.attack("david", "dan"));
		
		System.out.println("Starting Load Generator");
		LoadGenerator gen = new LoadGenerator(stub);
		System.out.println("adding users");
		gen.setup();
		System.out.println("Starting random actions!");
		gen.randomActions();
		User u = gen.getRandomUser();
		System.out.println("Spiking up actions for " + u.getName() + "!");
		gen.randomActions(u);
		System.out.println("Starting random actions again!");
		gen.randomActions();
		System.out.println("Ran Load Generator");
		System.out.println(ms.getCustomers().keySet());
		System.out.println(ms.getBanks().keySet());
		
		System.out.println("Test is over!");
		
//	       PID cpid = new PID();
//	       MyClosure c = new MyClosure(cpid);
//	       System.out.println("closure pid: " + cpid);
//	       System.out.println("before closure: " + AeolusLib.getPID());
//	       c.foo();
//	       System.out.println("after closure: " + AeolusLib.getPID());
	}
	private static void initFS(AeolusTag utag, AeolusTag btag) throws FileNotFoundException, InfoFlowControlException, IOException, AeolusException{
//		clearDir("/home");
		AeolusFile file = new AeolusFile(MintConfig.host, "/mint");
		AeolusLabel iLabel = new AeolusLabel();
		iLabel.addTag(utag);
		iLabel.addTag(btag);
		AeolusLib.endorse(utag);
		AeolusLib.endorse(btag);
		file.mkdir(new AeolusLabel(), iLabel);
		initCustomersDirectory(utag, btag);
		initBanksDirectory(utag, btag);
		AeolusLib.removeIntegrity(utag);
		AeolusLib.removeIntegrity(btag);
	}
	
	private static void initBanksDirectory(AeolusTag utag, AeolusTag btag) throws FileNotFoundException, InfoFlowControlException, IOException, AeolusException{
		AeolusLabel sLabel = new AeolusLabel();
		AeolusLabel iLabel = new AeolusLabel();
//		iLabel.addTag(utag);
		iLabel.addTag(btag);
		AeolusFile dir = new AeolusFile(MintConfig.host, MintConfig.banks);
		System.out.println("init banks");
	}
	
	private static void initCustomersDirectory(AeolusTag utag, AeolusTag btag) throws FileNotFoundException, InfoFlowControlException, IOException, AeolusException{
		AeolusLabel sLabel = new AeolusLabel();
		AeolusLabel iLabel = new AeolusLabel();
		iLabel.addTag(utag);
//		iLabel.addTag(btag);
		AeolusFile dir = new AeolusFile(MintConfig.host, MintConfig.customers);
		dir.mkdir(sLabel, iLabel);
	}
	private static MintServerState readServerStateFromDisk(String serverStatePath){
		AeolusFile state = new AeolusFile(MintConfig.host, serverStatePath);
		
		return null;
	}
	private static void clearDir(String path) throws FileNotFoundException, InfoFlowControlException, IOException, AeolusException{
		AeolusFile file = new AeolusFile(MintConfig.host, path);
		AeolusFile f;
		for (String s : file.list()){
			f = new AeolusFile(MintConfig.host, path + "/" + s);
			if (f != null){
				if (f.list() != null){
					clearDir(path + "/" + s);
				}
				f.delete();
			}
		}
		file.delete();
	}
}
class MyClosure extends AeolusClosure {
	   public MyClosure(PID pid) throws AuthorityException {
	       super(pid);
	   }

	   void foo() {
	       System.out.println("in closure: " + AeolusLib.getPID());

	   }
	}
