package edu.mit.csail.aeolus.apps.mint3;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.math.BigInteger;
import java.security.SecureRandom;
import java.sql.Timestamp;

import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.exceptions.InfoFlowControlException;
import edu.mit.csail.aeolus.filesystem.FileAttributes;

public class Tests {

	public static void main(String[] args) throws InfoFlowControlException, AuthorityException, AeolusException, IOException, ClassNotFoundException{
//		testOOS();
//		testBigInt();
		testTimestamp();
	}

	private static void testBigInt() {
		System.out.println(new BigInteger(130, new SecureRandom()).toString(32));
	}

	private static void testOOS() throws IOException, ClassNotFoundException {
		FileAttributes cus = new FileAttributes();
		FileAttributes kus = new FileAttributes();
		File f = new File("/home/wjarjoui/myFile.txt");
		f.createNewFile();
		FileOutputStream fos;
		ObjectOutputStream oos;
		fos = new FileOutputStream(f, true);
		oos = new ObjectOutputStream(fos){
			@Override
			  protected void writeStreamHeader() throws IOException {
			    // do not write a header
			  }
		};
		oos.writeObject(cus);
		oos.writeObject(kus);
		oos.writeObject(cus);
		oos.flush();
		oos.close();
		FileInputStream fis = new FileInputStream(f);
		ObjectInputStream ois = new ObjectInputStream(fis);
		System.out.println(ois.readObject());
		System.out.println(ois.readObject());
		System.out.println(ois.readObject());
		while(ois.available()>0)
			System.out.println(ois.readObject());
		ois.close();		
	}

	public static void readAttrs(String hiddenName) throws IOException, ClassNotFoundException {
		System.out.println("readAttrs");
		System.out.println(hiddenName);
		File f = new File(hiddenName);
		FileInputStream fis = new FileInputStream(f);
		ObjectInputStream ois = new ObjectInputStream(fis);
		System.out.println(ois.readObject());
		System.out.println(ois.available());
		System.out.println(ois.readObject());
		while(ois.available()>0)
			System.out.println(ois.readObject());
		ois.close();
	}
	private static void testTimestamp(){
	    java.util.Date today = new java.util.Date();
	    System.out.println(new Timestamp(today.getTime()));
	}
}
