package edu.mit.csail.aeolus.apps.mint3;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Callable;

import edu.mit.csail.aeolus.api.AeolusLib;
import edu.mit.csail.aeolus.api.PID;
import edu.mit.csail.aeolus.exceptions.AeolusException;

public class TransactionDownloader implements Callable<UserInfo> {

	private List<BankCredentialsWrapper> bCreds;
	private Map<String, BankClosure> closures;
	
	public TransactionDownloader(List<BankCredentialsWrapper> bCreds, Map<String, BankClosure> closures) {
		this.bCreds = bCreds;
		this.closures = closures;
	}

	@Override
	public UserInfo call() throws Exception {
		ArrayList<Transaction> txns = new ArrayList<Transaction>();
		for (BankCredentialsWrapper creds : bCreds){
			try {
				closures.get(creds.getBankName()).authCustomer(creds);
				txns.add(Utils.contactBankServer(creds));
			} catch (AeolusException e) {
				e.printStackTrace();
			}
		}
		PID pid  = new PID();
		UserInfo info = AeolusLib.call(new TransactionProcessor(txns), pid);
//		UserInfo info = AeolusLib.call(new TransactionProcessor(txns), server.getPublicPID());
		return info;
	}
}
	