package edu.mit.csail.aeolus.apps.testapps;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.lang.reflect.InvocationTargetException;
import java.util.concurrent.Callable;

import junit.framework.Assert;
import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.exceptions.RpcException;
import edu.mit.csail.aeolus.api.*;
import edu.mit.csail.aeolus.runtime.RuntimeConfig;

/**
 * Single PI test app (includes calls to shared state and file system)
 * 
 * @author viq
 * 
 */

public class TestApplication {

	public static void main(String[] args) throws AuthorityException,
			AeolusException, FileNotFoundException, IOException, RpcException,
			InvocationTargetException, ClassNotFoundException,
			NoSuchMethodException {
		System.out.println("STARTING TEST APP");


		AeolusTag Tag1 = new AeolusTag();
		AeolusLib.addSecrecy(Tag1);

		// Integer toShare = new Integer(5);
		// int sharedHandle = user.createSharedObject(new Label("1"), new Label(),
		// 		toShare);

		// AeolusCallable sharedCallable = new TestSharedCallable(sharedHandle);
		// user.fork(sharedCallable, new PrincipalID(3));

		AeolusLib.declassify(Tag1);

		// String filepath = "\testFile" + Math.random();
		// user.createFile(RuntimeConfig.get().getFsHostName(), filepath, new Label(),
						// new Label());
		// String content = "Hello World!";
		// user.writeFile(RuntimeConfig.get().getFsHostName(), filepath, content.getBytes(),
						// false);

		// AeolusCallable fileCallable = new TestFileCallable(filepath);
		// user.fork(fileCallable, new PrincipalID(4));

		// launch a PI
		PID PID0 = new PID();
		AeolusLib.launch("localhost", PID0,
				"edu.mit.csail.aeolus.apps.testapps.TestApplication3", "");

		System.out.println("TEST APP DONE");
	}

	private static class TestSharedCallable implements Callable {
		private static final long serialVersionUID = 1L;
		private int value;

		public TestSharedCallable(int sharedHandle) {
			value = sharedHandle;
		}

		public Void call() throws Exception {
			// Well, this won't be the same tag as was created above...
			AeolusTag Tag1 = new AeolusTag();
			AeolusLib.addSecrecy(Tag1);
			// try to access the shared state object
			// Integer result = (Integer) userd.getSharedObject(this.value);

			// System.out.println("GOT OBJECT " + result);

			// Assert.assertTrue(result.equals(5));

			// System.out.println("CALLABLE DONE");
			return null;

		}
	}

	private static class TestFileCallable implements Callable {
		private static final long serialVersionUID = 1L;
		private String path;

		public TestFileCallable(String filePath) {
			path = filePath;
		}

		public Void call() throws Exception {
			// byte[] content = new byte[20];
			// userd.readFile(RuntimeConfig.get().getFsHostName(), this.path, content);

			// System.out.println("READ: " + new String(content));

			// Assert.assertTrue(new String(content).equals("Hello World!"));

			// System.out.println("CALLABLE DONE");
			return null;
		}
	}
}
