package edu.mit.csail.aeolus.auditing;

import java.lang.reflect.Field;

public class AeolusApiConstants {
	
	public final static int CREATE_NODE = 0;
	public final static int CREATE_NODE_REPLY = -1;
	public final static int PI_LAUNCH = 1;
	public final static int PI_LAUNCH_REQUEST = 2;
	public final static int PI_LAUNCH_REPLY = -2;
	public final static int PI_SHUTDOWN_REQUEST = 3;
	public final static int PI_SHUTDOWN_REPLY = 3;
	public final static int PI_SHUTDOWN = -4;
	public final static int USER_THREAD_LAUNCH = 4;
	
	// Proxy Object METHODS
	
	// shared state
	public final static int GET_SHARED_ROOT = 5;
	public final static int GET_SHARED_ROOT_REPLY = 6;
	public final static int UPDATE_SHARED_ROOT = 7;
	public final static int UPDATE_SHARED_ROOT_REPLY = 8;
	public final static int CREATE_SHARED_OBJECT = 9;
	public final static int CREATE_SHARED_OBJECT_REPLY = 10;
	public final static int GET_SHARED_OBJECT = 11;
	public final static int GET_SHARED_OBJECT_REPLY = 12;
	public final static int UPDATE_SHARED_OBJECT = 13;
	public final static int UPDATE_SHARED_OBJECT_REPLY = 14;
	public final static int DELETE_SHARED_OBJECT = 15;
	public final static int DELETE_SHARED_OBJECT_REPLY = 16;
	public final static int CREATE_SHARED_QUEUE = 17;
	public final static int CREATE_SHARED_QUEUE_REPLY = 18;
	public final static int ENQUEUE = 19;
	public final static int ENQUEUE_REPLY = 20;
	public final static int DEQUEUE = 21;
	public final static int DEQUEUE_REPLY = 22;
	public final static int WAIT_AND_DEQUEUE = 23;
	public final static int WAIT_AND_DEQUEUE_REPLY = 24;
	public final static int DELETE_SHARED_QUEUE = 25;
	public final static int DELETE_SHARED_QUEUE_REPLY = 26;
	public final static int CREATE_SHARED_LOCK = 27;
	public final static int CREATE_SHARED_LOCK_REPLY = 28;
	public final static int LOCK = 29;
	public final static int LOCK_REPLY = 30;
	public final static int TRY_LOCK = 31;
	public final static int TRY_LOCK_REPLY = 32;
	public final static int UNLOCK = 33;
	public final static int UNLOCK_REPLY = 34;
	public final static int DELETE_SHARED_LOCK = 35;
	public final static int DELETE_SHARED_LOCK_REPLY = 36;

	// file system
	public final static int CREATE_FILE = 37;
	public final static int CREATE_FILE_REPLY = 38;
	public final static int READ_FILE = 39;
	public final static int WRITE_FILE = 41;
	public final static int DELETE_FILE = 43;
	public final static int DELETE_FILE_REPLY = 44;
	public final static int CREATE_DIRECTORY = 51;
	public final static int CREATE_DIRECTORY_REPLY = 52;
	public final static int LIST_DIRECTORY = 53;
	public final static int REMOVE_DIRECTORY = 55;
	public final static int REMOVE_DIRECTORY_REPLY = 56;
	public final static int GET_SECRECY_LABEL = 57;
	public final static int GET_INTEGRITY_LABEL = 58;
	public final static int CLOSE_FILESTREAM = 59;
	public final static int OPEN_READ_FILESTREAM = 61;
	public final static int OPEN_WRITE_FILESTREAM = 63;
	
	// fork, call, closures
	public final static int CALL = 65;
	public final static int CALL_REPLY = 66;
	public final static int CALL_CLOSURE = 67;
	public final static int CALL_CLOSURE_REPLY = 68;
	public final static int FORK = 69;

	// AUTHORITY SERVER EVENT
	public static final int AUTHORITY_START = 300;
	public final static int AUTHORITY_CREATE_PRINCIPAL = 370;
	public final static int AUTHORITY_CREATE_TAG = 374;
	public final static int AUTHORITY_CREATE_SUBTAG = 376;
	public final static int AUTHORITY_ACT_FOR = 378;
	public final static int AUTHORITY_REVOKE_ACT_FOR = 379;
	public final static int AUTHORITY_DELEGATE = 380;
	public final static int AUTHORITY_REVOKE_DELEGATE = 381;
	public final static int AUTHORITY_DELEGATE_REPLY = 384;
	
	// authority / label manipulations
	public final static int CREATE_PRINCIPAL = 70;
	public final static int CREATE_PRINCIPAL_REPLY = 71;			// Hrm.
	public final static int CREATE_PRINCIPAL_NEWCORE = 72;
	public final static int CREATE_PRINCIPAL_NEWCORE_REPLY = 73;
	public final static int CREATE_TAG = 74;
	public final static int CREATE_TAG_REPLY = 75;
	public final static int CREATE_SUBTAG = 76;
	public final static int CREATE_SUBTAG_REPLY = 77;
	public final static int ACT_FOR = 78;
	public final static int REVOKE_ACT_FOR = 79;
	public final static int DELEGATE = 80;
	public final static int REVOKE_DELEGATE = 81;
	public final static int ACT_FOR_REPLY = 82;					// Hrm.
	public final static int REVOKE_ACT_FOR_REPLY = 83;
	public final static int DELEGATE_REPLY = 84;
	public final static int REVOKE_DELEGATE_REPLY = 85;
	
	public final static int GET_IFC = 86;
	public final static int ADD_SECRECY = 87;
	public final static int REMOVE_INTEGRITY = 88;
	public final static int DECLASSIFY = 89;
	public final static int ENDORSE = 90;
	
	// Closure things
	// TODO: will be removed in the NEW version.
	public final static int CREATE_CLOSURE = 91;
	public final static int GET_CLOSURE = 92;
	public final static int CREATE_CLOSURE_REPLY = 93;
	public final static int CLOSURE_ACT_FOR = 94;
	public final static int CLOSURE_DELEGATE = 95;
	public final static int CLOSURE_ACT_FOR_REPLY = 96;
	public final static int CLOSURE_DELEGATE_REPLY = 97;
	
	// rpc
	public final static int REGISTER_SERVICE = 98;
	public final static int GET_SERVICE = 99;
	public final static int SEND_RPC = 100;
	public final static int RECEIVE_RPC = 101;
	public final static int SEND_RPC_REPLY = 102;
	public final static int RECEIVE_RPC_REPLY = 103;

	// io
	public final static int WRITE_TO_IODEVICE = 104;
	public final static int READ_FROM_IODEVICE = 105;

	public final static int SHARED_CALL = 106;
	public final static int SHARED_RETURN = 107;	
	
	// file server
	public final static int FS_LAUNCH = 200;
	public final static int FS_CREATE_FILE = 201;
	public final static int FS_DELETE_FILE = 204;
	public final static int FS_CREATE_DIR = 205;
	public final static int FS_DELETE_DIR = 207;

	
	// boxes
	public final static int CREATE_BOX = 300;
	public final static int GET_BOX_CONTENT = 301;
	public final static int PUT_BOX_CONTENT = 302;
	public final static int GET_INNER_S = 303;
	public final static int GET_INNER_I = 304;
	public final static int GET_OUTER_S = 305;
	public final static int GET_OUTER_I = 306;
	
	public final static int DELETE_NODE_REQUEST = 307;
	public final static int DELETE_NODE_REPLY = 308;
	
	
public final static int APP_EVENT_RECEIVE_RPC_REPLY = 500;
	
	public static final int LOAD_CLASS = 700;
	public static final int APPLICATION_LVL = 1000;
	
	// AuthServer
	
	
	public static String getMethodName(int methodNr)
	{
		
		try {
		    Class<?> c = AeolusApiConstants.class;

		    Field[] methods = c.getDeclaredFields();
		    for(Field f: methods)
		    {
		    	if(f.getInt(f) == methodNr)
		    	{
		    		return f.getName();
		    	}
		    }
		    //out.format(fmt, "before", "chapters", book.chapters);
	  	    //chap.setLong(book, 12);
		    //out.format(fmt, "after", "chapters", chap.getLong(book));
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return "";
	}
		
	
}

