package edu.mit.csail.aeolus.auditing;

import java.io.Serializable;

/**
 * This class is used to store information about
 * the cache line used to determine authority.
 * 
 * If the cache line didn't previously exist,
 * this will contain the authority path. If it did,
 * this will contain a unique (to the VN,GEN) identifier.
 * 
 * @author blanks
 *
 */
public class CacheLineID implements Serializable {

	private static final long serialVersionUID = 1L;

	public final long id;
	public final AuthorityProof proof;
	
	public CacheLineID(Long ident) {
		id = ident;
		this.proof = null;
	}

	public CacheLineID(AuthorityProof proof, Long ident) {
		id = ident;
		this.proof = proof;
	}

}
