package edu.mit.csail.aeolus.auditing;

import java.util.concurrent.BlockingQueue;

import edu.mit.csail.aeolus.auditing.graphdb.Analysis;
import edu.mit.csail.aeolus.auditing.graphdb.wrappers.AbstractEvent;

/**
 * This class pushes events from a given queue through
 * a given analysis.
 * @author blanks
 *
 */
public class EventQueueReader implements Runnable{
	BlockingQueue<AbstractEvent> events;    
	Analysis p;

	int processed = 0;
	
	public EventQueueReader(Analysis p, BlockingQueue<AbstractEvent> input){
		this.p = p;
		this.events = input;
	}
	
	@Override
	public void run(){
		while(true){
			try{
				AbstractEvent ee = events.take();
				processed++;
				tryProcess(ee);
			}catch(InterruptedException e){
			}
		}
	}

	private void tryProcess(AbstractEvent curEv){
		p.processEvent(curEv);
	}

}
