package edu.mit.csail.aeolus.auditing;

import java.rmi.Remote;
import java.rmi.RemoteException;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Queue;

public interface LoggingServiceInterface extends Remote {
	
	public void receiveLogs(Integer platformid,  Date timestamp, HashMap<Long, ArrayList<EventRecord>> eventsTable) throws RemoteException;
	
	public void receiveFileSystemLogs(String hostname, Date timestamp, Queue<EventRecord> eventsList) throws RemoteException;
		
	public int getSessionUid() throws RemoteException;

	public void shutdownService() throws RemoteException;

	public void printStats() throws RemoteException;

	public void receiveAuthLogs(Date timestamp, ArrayList<EventRecord> eventsList) throws RemoteException;

	public List<EventRecord> getAllRecords() throws RemoteException, SQLException;
}
