package edu.mit.csail.aeolus.auditing.graphdb;

import java.util.ArrayList;
import java.util.List;

import edu.mit.csail.aeolus.auditing.graphdb.wrappers.AbstractEvent;
import edu.mit.csail.aeolus.auditing.graphdb.wrappers.EventVisitor;
import edu.mit.csail.aeolus.auditing.graphdb.wrappers.PlatformUserEvent;

/**
 * The class holds all of the various analyses that will be performed
 * on the event graph before events are stored in SQL or sent to the
 * Watcher system.
 * @author blanks
 */
public class AnalyseFull implements Analysis{
	List<EventVisitor<?>> subProcessors;
	AnalyseLabel proc;

	public AnalyseFull(){
		proc = new AnalyseLabel();
		subProcessors = new ArrayList<EventVisitor<?>>();
		subProcessors.add(new AnalyseAuthority());
	}

	@Override
	public void processEvent(AbstractEvent e){
		if(e instanceof PlatformUserEvent)
			proc.visit((PlatformUserEvent)e);
		for(EventVisitor<?> subproc : subProcessors){
			e.accept(subproc);
		}

		e.markProcessed();
		e.disposeNode(); //NoOP
		try{
			SQLEventStore.get().insertEvent(e);
		}catch(Exception ex){
			ex.printStackTrace();
		}

	}
}
