package edu.mit.csail.aeolus.auditing.graphdb.predicates;

/**
 * This enumeration holds the various fields used for logging events. Each field
 * specifies the PGSQL type that it will use.
 * @author blanks
 *
 */
public enum EventAttribute {
    OP_NAME("INT"),
	IS_IMMEDIATE("INT"),
	FILENAME("VARCHAR(128)"),
	OBJ_SECRECY("integer[]"),
	OBJ_INTEGRITY("integer[]"),
	SECRECY("integer[]"),
	INTEGRITY("integer[]"),
	EVENT_COUNTER("BIGINT"),
	RUNNING_PRINCIPAL("INT"),
	GRANTOR("INT"),
	GRANTEE("INT"),
	PRINCIPAL_CREATED("INT"),
	PRINCIPAL_CREATOR("INT"),
	TAG_CREATED("INT"),
	TAG_PARENT("INT"),
	TAG_DELEGATED("INT"),
	REVOKER("INT"),
	AUTH_PROOF("VARCHAR(128)"),
	TAGS_MODIFIED("VARCHAR(128)"),
	ROOT_PRINCIPAL("INT"),
	HOSTNAME("VARCHAR(128)"),
	FS_START_TLM("BIGINT"),
	FS_END_TLM("BIGINT"),
	SERVICE_NAME("VARCHAR(128)"),
	SERVICE_CLASS_NAME("VARCHAR(128)"),
	APP_NAME("VARCHAR(128)"),
	APP_ARG("VARCHAR(128)"),
	VIRTUAL_NODE_ID("INT"),
	LAUNCHED_PRINCIPAL("INT"),
	CALLER_PRINCIPAL("INT"),
	METHOD_NAME("VARCHAR(256)"),
	INFO_FLOW_STATE("VARCHAR(128)"),
	INVALIDATION("INT"),
	SWITCHED_PRINCIPAL("INT"), 
	CLOSURE_ID("INT"), 
	TIMESTAMP("TIMESTAMP");
    
    public final String type;
    EventAttribute(String type){
    	this.type = type;
    }
}
