package edu.mit.csail.aeolus.auditing.graphdb.wrappers;

import edu.mit.csail.aeolus.auditing.EventRecord;
import edu.mit.csail.aeolus.infoflow.PrincipalID;

public class ActForClient extends AuthorityClientEvent{	
	private static final long serialVersionUID = 1L;

	public ActForClient(EventRecord n) {
		super(n);
	}
	
	public PrincipalID getActedFor(){
		return (PrincipalID) this.getParams()[0];
	}

	public PrincipalID getActor(){
		return (PrincipalID) this.getParams()[1];
	}

	public <T> T accept(EventVisitor<T> v){
		return v.visit(this);
	}
	
	@Override
	public String toString(){
		return String.format("ActForClient : %s acts for %s",
				getActor(), getActedFor());
	}
}
