package edu.mit.csail.aeolus.auditing.graphdb.wrappers;

import java.util.ArrayList;

import edu.mit.csail.aeolus.auditing.AuthorityProof;
import edu.mit.csail.aeolus.auditing.CacheLineID;
import edu.mit.csail.aeolus.auditing.EventRecord;
import edu.mit.csail.aeolus.infoflow.TagID;


public class AddIntegrityEvent extends LabelEvent{
	private static final long serialVersionUID = 1L;
	private AuthorityProof proof = null;
	private boolean proofInit = false;
	
	public AddIntegrityEvent(EventRecord n) {
		super(n);
		// TODO : fetching the PROOF PROPERTY.
		//		Object o64 = n.getProperty(super.PROOF_PROPERTY, null);
//		if(o64 != null){
//			AuthorityProof proof = 
//				(AuthorityProof) HelperUtils.deserializeFromB64String((String) o64);
//			this.proof = proof;
//			this.proofInit = true;
//		}
	}

	@SuppressWarnings("unchecked")
	public ArrayList<TagID> getAddedTags(){
		return (ArrayList<TagID>) this.getParams()[0];
	}

	public <T> T accept(EventVisitor<T> v){
		return v.visit(this);
	}

	public CacheLineID getCacheLineID() {
		return (CacheLineID) super.getReturnValue();
	}
	
	public AuthorityProof getProof() {
		if(this.proofInit)
			return proof;
		else
			return null;
	}

	public void setProof(AuthorityProof proof) {
		proofInit = true;
		this.proof = proof;
	}
}
