package edu.mit.csail.aeolus.auditing.graphdb.wrappers;

import edu.mit.csail.aeolus.auditing.EventRecord;
import edu.mit.csail.aeolus.infoflow.ClosureID;
import edu.mit.csail.aeolus.infoflow.PrincipalID;

public class CallClosure extends ProcessEvent{
	private static final long serialVersionUID = -3004468885190231268L;

	public CallClosure(EventRecord n) {
		super(n);
	}

	// Do we also want to get the PID of the called closure ?
	//  - in the new version, the answer is YES.
	public ClosureID getClosureID(){
		return (ClosureID) getParams()[0];
	}

	public <T> T accept(EventVisitor<T> v){
		return v.visit(this);
	}

    @Override
    public PrincipalID getRaisedPrincipal() {
	return (PrincipalID) this.getParams()[1];
    }

}
