package edu.mit.csail.aeolus.auditing.graphdb.wrappers;

import edu.mit.csail.aeolus.auditing.EventRecord;
import edu.mit.csail.aeolus.infoflow.Label;

public abstract class FileEvent extends PlatformUserEvent {
	private static final long serialVersionUID = 1L;
	private long start_tlm;
	private long end_tlm;
	public FileEvent(EventRecord n) {
		super(n);
		start_tlm = n.getFsBeforeTime();
		end_tlm = n.getFsAfterTime();
	}

	public abstract String getFilePath();

	// TODO: the processors need to add this information
	// to the event!
	public Label getSecrecy(){
		return null;
	}
	public Label getIntegrity(){
		return null;
	}
	
	public Long getFSStartTLM()
	{
		return new Long(start_tlm);
	}
	
	public Long getFSEndTLM()
	{
		return new Long(end_tlm);
	}
}
