package edu.mit.csail.aeolus.auditing.graphdb.wrappers;

import java.io.Serializable;

import edu.mit.csail.aeolus.auditing.EventRecord;
import edu.mit.csail.aeolus.infoflow.Label;

public abstract class PlatformUserEvent extends AbstractEvent{
	private static final long serialVersionUID = 1L;

	private Label secrecy = null, integrity = null;
	
	final static String secrecy_prop = "PROCESS_SECRECY";
	final static String integrity_prop = "INTEGRITY_SECRECY";
	
	PlatformUserEvent(EventRecord n) {
		super(n);
		integrity = new Label();
		secrecy = new Label();
	}
	public PlatformUserEvent(int op, Serializable[] params) {
		super(op, params);
		this.secrecy = new Label();
		this.integrity = new Label();
	}
	final public Label getProcessSecrecy(){
		return secrecy;
	}
	final public Label getProcessIntegrity(){
		return integrity;
	}
	final public void setProcessSecrecy(Label l){
		this.secrecy = l;
	}
	final public void setProcessIntegrity(Label l){
		this.integrity = l;
	}
}
