package edu.mit.csail.aeolus.authority.api;

import java.io.Serializable;

import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.stream.client.InvalidationPacket;

public class AuthReply<E> implements Serializable{
	private static final long serialVersionUID = 1L;
	public final int invalidationNumber;
	/**
	 * This EventID is the ID for the Authority Event that this 
	 * reply is from.
	 */
	public final EventID event;
	/**
	 * When running in piggyback mode, this is filled with the 
	 * required invalidations for the authority client to get up to
	 * speed.
	 */
	public InvalidationPacket piggyback;
	public final E value;

	public AuthReply(EventID event, E value){
		this(event, null, value);
	}
	public AuthReply(EventID event,
			InvalidationPacket piggyback, E value) {
		this.invalidationNumber = -1;
		this.piggyback = piggyback;
		this.value = value;
		this.event = event;
	}
}
