package edu.mit.csail.aeolus.authority.api;

import java.io.Serializable;
import java.util.List;

public class CoreContents implements Serializable {
	
	private static final long serialVersionUID = 857519273221297718L;
	List<TaintTableEntry> taintEntries;
	List<PrincipalTableEntry> principalEntries;
    List<GrantTableEntry> grantEntries;
    List<LinkTableEntry> linkEntries;
    List<ClosureTableEntry> closureEntries;
    List<CompoundTagTableEntry> compoundEntries;

    public final Integer coreID;
	private List<NodeTableEntry> nodeTableEntries;
	
	public CoreContents(Integer coreID){
		this.coreID = coreID;
	}
	public List<CompoundTagTableEntry> getCompoundEntries() {
		return compoundEntries;
	}
    public List<TaintTableEntry> getTaintEntries() {
		return taintEntries;
	}
	public List<PrincipalTableEntry> getPrincipalEntries() {
		return principalEntries;
	}
	public List<GrantTableEntry> getGrantEntries() {
		return grantEntries;
	}
	public List<LinkTableEntry> getLinkEntries() {
		return linkEntries;
	}
	public List<ClosureTableEntry> getClosureEntries() {
		return closureEntries;
	}
	public List<NodeTableEntry> getNodeEntries() {
		return nodeTableEntries;
	}
	public void setTaintEntries(List<TaintTableEntry> taintEntries) {
		this.taintEntries = taintEntries;
	}
	public void setPrincipalEntries(List<PrincipalTableEntry> principalEntries) {
		this.principalEntries = principalEntries;
	}
	public void setGrantEntries(List<GrantTableEntry> grantEntries) {
		this.grantEntries = grantEntries;
	}
	public void setLinkEntries(List<LinkTableEntry> linkEntries) {
		this.linkEntries = linkEntries;
	}
	public void setClosureEntries(List<ClosureTableEntry> closureEntries) {
		this.closureEntries = closureEntries;
	}
	public void setCompoundTagEntries(
			List<CompoundTagTableEntry> compoundEntries) {
		this.compoundEntries = compoundEntries;
	}
	public void setNodeTableEntries(List<NodeTableEntry> entries){
		this.nodeTableEntries = entries;
	}
}
