package edu.mit.csail.aeolus.authority.api;

import java.io.Serializable;

import edu.mit.csail.aeolus.infoflow.PrincipalID;
import edu.mit.csail.aeolus.infoflow.TagID;

public class GrantTableEntry implements Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -1141684765589083759L;
	public final int grantorPid, granteePid, tid, coreId;
	@Override
	public String toString() {
		return String.format("%d:%d:%d:%d", grantorPid,granteePid, tid, coreId);
	}
	public GrantTableEntry(int grantorPid, int granteePid, int tid, int coreId) {
		this.grantorPid = grantorPid;
		this.granteePid = granteePid;
		this.tid = tid;
		this.coreId = coreId;
	}
	public GrantTableEntry(PrincipalID grantorPid, PrincipalID granteePid, TagID tid, int coreId) {
		this.grantorPid = grantorPid.getValue();
		this.granteePid = granteePid.getValue();
		this.tid = tid.getValue();
		this.coreId = coreId;
	}
	@Override
	public boolean equals(Object o){
		if(!(o instanceof GrantTableEntry))
			return false;
		GrantTableEntry gO = (GrantTableEntry) o;
		return this.grantorPid == gO.grantorPid && this.granteePid == gO.granteePid &&
			this.tid == gO.tid && this.coreId == gO.coreId;
	}
}
