package edu.mit.csail.aeolus.authority.api;

import java.io.Serializable;

import edu.mit.csail.aeolus.infoflow.PrincipalID;

public class LinkTableEntry implements Serializable{
	/**
	 * 
	 */
	private static final long serialVersionUID = 5334135405585027054L;
	public int pidFrom;
    public int pidTo;
    public LinkType linkType;
    public int coreId;
    public int coreIdTo;
    
    public LinkTableEntry(){
    	super();
    }
    
    public LinkTableEntry(int pidFrom, int pidTo, LinkType linkType){
    	super();
    	this.pidFrom = pidFrom;
    	this.pidTo = pidTo;
    	this.linkType = linkType;
    }
    
    public LinkTableEntry(PrincipalID actor, PrincipalID actee,
			LinkType lActsfor) {
    	super();
    	this.pidFrom = actor.getValue();
    	this.pidTo = actee.getValue();
    	this.linkType = lActsfor;
    }

	public String toString(){
    	return "" + pidFrom + " -> " + pidTo;
    }
    
    public static enum LinkType{
        L_OWNS(0),L_ACTSFOR(1);
        public final int id;
        LinkType(int id){
        	this.id = id;
        }
    }
}
