package edu.mit.csail.aeolus.authority.client;

import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class EvictionFifo<T> extends EvictionMgr<T> {
	Queue<T> fifoQueue;

	public EvictionFifo() {
		fifoQueue = new LinkedList<T>();
	}

	public List<T> evictAndRemove(int numEntriesToEvict) {
		List<T> candidates = new LinkedList<T>();
		try {

			numEvictRequests++;

			for (int i = 0; i < numEntriesToEvict; i++) {
				int numEntriesQueued = fifoQueue.size();

				if (numEntriesQueued <= 0) {
					// there are no more entries that can be evicted
					break;
				}

				// attempt to remove and remember candidate
				T authKey = fifoQueue.poll();
				candidates.add(authKey);
				numEvictions++;
			}
		} catch (Exception e) {
			System.err.println("EvictAndRemove: " + e);
		}
		return candidates;
	}

	public void notifyAdded(T key) {
		try {
			fifoQueue.add(key);
			// fifoQueue.Enqueue(key);
		} catch (Exception e) {
			System.err.println("NotifyAdded: " + e);
		}
	}

	public void notifyRemoved(T key) {
		try {
			Queue<T> fifoQueueRemoved = new LinkedList<T>();
			for (int i = 0; i < fifoQueue.size(); i++) {
				T keyToCheck = fifoQueue.poll();
				if (keyToCheck != key)
					fifoQueueRemoved.add(keyToCheck);
			}
			fifoQueue = fifoQueueRemoved;
		} catch (Exception e) {
			System.err.println("NotifyRemoved: " + e);
		}
	}

	public void notifyLookup(T key) {
		// nothing needs to be done
	}
}
