package edu.mit.csail.aeolus.authority.client;

import java.util.List;

public abstract class EvictionMgr<T> {
    public int numEvictRequests = 0;
    public int numEvictions = 0;

    // This is called to request decision on which candidates should be removed
    // evictAndRemove(int numEntriesToEvict, out List<AuthLookupKey_t> candidates
    public abstract List<T> evictAndRemove(int numEntriesToEvict);

    public abstract void notifyAdded(T key);

    public abstract void notifyRemoved(T key);

    public abstract void notifyLookup(T key);
}
