package edu.mit.csail.aeolus.authority.client;

import java.util.LinkedList;
import java.util.List;
import java.util.Random;

public class EvictionRandom<T> extends EvictionMgr<T> {

	List<T> keysList;

	Random rgen;

	public EvictionRandom() {
		keysList = new LinkedList<T>();
		rgen = new Random();
	}

	public List<T> evictAndRemove(int numEntriesToEvict) {
		List<T> candidates = new LinkedList<T>();
		try {

			numEvictRequests++;

			for (int i = 0; i < numEntriesToEvict; i++) {
				int numEntriesKnown = keysList.size();

				if (numEntriesKnown <= 0) {
					// there are no more entries that can be evicted
					break;
				}

				// int victimIndex = (numEntriesKnown > 1) ? rgen.Next(0,
				// numEntriesKnown - 1) : 0;
				int victimIndex = (numEntriesKnown > 1) ? rgen
						.nextInt(numEntriesKnown - 1) : 0;

				// attempt to remove and remember candidate
				candidates.add(keysList.get(victimIndex));
				keysList.remove(victimIndex);
				numEvictions++;
			}
		} catch (Exception e) {
			// throw new Exception("EvictAndRemove: " + e.getMessage());
			System.err.println("EvictAndRemove: " + e.getMessage());
		}
		return candidates;
	}

	public void notifyAdded(T key) {
		try {
			keysList.add(key);
		} catch (Exception e) {
			// throw new Exception("NotifyAdded: " + e.getMessage());
			System.err.println("NotifyAdded: " + e.getMessage());
		}
	}

	public void notifyRemoved(T key) {
		try {
			keysList.remove(key);
		} catch (Exception e) {
			// throw new Exception("NotifyRemoved: " + e.getMessage());
			System.err.println("NotifyRemoved: " + e.getMessage());
		}
	}

	public void notifyLookup(T key) {
		// nothing needs to be done here
	}
}
