package edu.mit.csail.aeolus.authority.server;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Timer;
import java.util.TimerTask;

import edu.mit.csail.aeolus.auditing.AeolusLoggingClient;
import edu.mit.csail.aeolus.auditing.EventRecord;

public class AuthLogger {

	ArrayList<EventRecord> logRecords = new ArrayList<EventRecord>();
	AeolusLoggingClient logClient = new AeolusLoggingClient();
	final private Timer timer = new Timer();
	
	private class ScheduleTask extends TimerTask{
		@Override
		public void run() {
			submitLogRecords();
			timer.schedule(new ScheduleTask(), 5000);
		}
	}
	
	public void startScheduler(){
		timer.schedule(new ScheduleTask(), 5000);
	}
	
	public void submitLogRecords(){
		if(logRecords.isEmpty())
			return;
		ArrayList<EventRecord> toSubmit = logRecords;
		synchronized(this){
			logRecords = new ArrayList<EventRecord>();
		}
		logClient.sendAuthLogToServer(Calendar.getInstance().getTime(), toSubmit);
		
	}
	
	public synchronized void push(EventRecord myEvent) {
		logRecords.add(myEvent);
	}

	public void destroy() {
		timer.cancel();
	}

}
