package edu.mit.csail.aeolus.authority.server;

import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.infoflow.PrincipalID;
import edu.mit.csail.aeolus.stream.server.api.RegisterReturn;

public class AuthMgrLogTesting {
	
	static int reps = 10;
	static int micros = 250;
	
	public static void main(String[] args) throws AuthorityException{
		AuthorityManager mgr;
		mgr = new AuthorityManager();

		
		long min = Long.MAX_VALUE;
		for(int i = 0; i < reps; i++){
			if(i % 2 == 0)
				System.out.println(i);
			mgr.createAuthorityServer();

			RegisterReturn rr = mgr.registerClient("testString");
			PrincipalID root = rr.rootPID;
			for(int k = 0; k < micros; k++){
				mgr.createPrincipal(root, new EventID("1"));
			}
			
			long start = System.currentTimeMillis();
			for(int k = 0; k < micros; k++){
				mgr.createPrincipal(root, new EventID("1"));
			}
			long time = System.currentTimeMillis() - start;
			if(time < min)
				min = time;
			
			mgr.destroy();
		}
		System.out.println(min);
	}
}
