package edu.mit.csail.aeolus.authority.server;

import java.rmi.RemoteException;

import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.authority.api.InterfaceAuthorityServer;
import edu.mit.csail.aeolus.infoflow.PrincipalID;

/**
 * This does some pretty rudimentary performance testing between MSSQL and MySQL implementations of the
 * Authority State.
 */
public class AuthMgrTest {

	AuthorityManager mgr;

	public static void main(String[] args) throws RemoteException, AuthorityException{
//		AuthorityConfiguration config = new AuthorityConfiguration("localhost/", "aeolus", "aeolus", "b1b1");
		AuthorityManager mgrMySql = new AuthorityManager();
		perfTest(mgrMySql, "MySQL");
		
//		AuthorityManagerMSSQL mgrMSSQL = new AuthorityManagerMSSQL();
//		perfTest(mgrMSSQL, "MSSQL");
	}
	
	private static void perfTest(InterfaceAuthorityServer auth, String type) throws RemoteException, AuthorityException{
		long s = System.currentTimeMillis();
		auth.createAuthorityServer();
		PrincipalID p = auth.registerClient(type).rootPID;
		long e = System.currentTimeMillis();
		System.out.println(type + " Start: \t\t" + (e - s));
		
		s = System.currentTimeMillis();
		for(int i = 0; i < 1000; i++){
			auth.createPrincipal(p, null);
		}
		e = System.currentTimeMillis();
		
		System.out.println(type + " 1000 Principal: \t" + (e - s));
		
		s = System.currentTimeMillis();
		auth.createSnapshot(5);
		e = System.currentTimeMillis();
		System.out.println(type + " Snaps: \t\t" + (e - s));
	}
}
