package edu.mit.csail.aeolus.filesystem;

import java.io.Serializable;

import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.infoflow.Label;

/**
 * Temporary substitute for storing attributes of a data file 
 * (currently read from an attributes file)
 * 
 * Java 7 will enable interactions with file meta-data directly
 * 
 * @author viq
 *
 */
public class FileAttributes implements Serializable{
	
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	public Label sLabel;
	public Label iLabel;
	public EventID lastModified;
	public String uniqueName;
	public String userName;
	
	public FileAttributes(){}
	
	public FileAttributes(Label fileSLabel, Label fileILabel, EventID lastModifierId)
	{
		sLabel = fileSLabel;
		iLabel = fileILabel;
		lastModified = lastModifierId;
	}
	
	public FileAttributes(Label fileSLabel, Label fileILabel, String name, String unique)
	{
		sLabel = fileSLabel;
		iLabel = fileILabel;
		uniqueName = unique;
		userName = name;
	}
	
	@Override
	public String toString() {
		StringBuffer buff = new StringBuffer();
		buff.append(this.getClass());
		buff.append("\n uniquename: ");
		buff.append(uniqueName);
		buff.append("\n username: ");
		buff.append(userName);
		buff.append("\n Secrecy: ");
		buff.append(sLabel);
		buff.append("\n Integrity: ");
		buff.append(iLabel);
		return buff.toString();
	}
}
