package edu.mit.csail.aeolus.filesystem;

import java.io.Serializable;
import java.util.List;

/**
 * Server sends a set of file names to file clients in order to invalidate
 * entries corresponding to these files in their caches
 * 
 * If a client is no longer registered with the server (e.g. connection to this client timed out)
 * the server will send a special packet to indicate that the client should clear the entire cache
 * 
 * @author viq
 *
 */
public class FileInvalidationPacket implements Serializable {
	private static final long serialVersionUID = 5516619816479228784L;
	public List<String> invalidations;
	public boolean globalInvalidation;
	
	public FileInvalidationPacket(List<String> filesToInvalidate)
	{
		this.invalidations = filesToInvalidate;
		this.globalInvalidation = false;
	}
	
	public FileInvalidationPacket()
	{
		this.globalInvalidation = true;
	}
}
