package edu.mit.csail.aeolus.filesystem;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.rmi.Remote;
import java.rmi.RemoteException;

import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.exceptions.InfoFlowControlException;
import edu.mit.csail.aeolus.infoflow.Label;


/**
 * Interface to the remote file system server
 * 
 * @author viq
 *
 */

public interface FileSystemRemoteInterface extends Remote {
	
	public void registerFSClient(String clientServiceName) throws RemoteException;
	
	public FileSystemReply<Boolean> createDir(String filePath, Label sLabelFile, Label iLabelFile,
			Label sLabelRequestor, Label iLabelRequestor, EventID opEid) 
			throws RemoteException, InfoFlowControlException, IOException;

	public FileSystemReply<Boolean> createFile(String filePath, Label sLabelFile, Label iLabelFile,
			Label sLabelRequestor, Label iLabelRequestor, EventID opEid) 
			throws RemoteException, IOException, InfoFlowControlException;
	
	public FileSystemReply<Boolean> delete(String filePath, Label sLabelRequestor, Label iLabelRequestor, 
			EventID opEid) throws RemoteException, InfoFlowControlException, FileNotFoundException, IOException;	
}
