package edu.mit.csail.aeolus.filesystem;

import java.io.Serializable;

import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.infoflow.Label;

/**
 * Contains the file system operation result 
 * and its predecessor event id
 * 
 * @author viq
 *
 */
public class FileSystemReply<T> implements Serializable{
	private static final long serialVersionUID = 2831995819128150418L;
	
	public T opResult;
	public Label fileSLabel;
	public Label fileILabel;
	public EventID predecessorEventId;
	public long beforeTime;
	public long afterTime;
	
	public FileSystemReply(T objContent, Label fileSLabel, Label fileILabel, EventID predEvent)
	{
		this.opResult = objContent;
		this.fileSLabel = fileSLabel;
		this.fileILabel = fileILabel;
		this.predecessorEventId = predEvent;
	}
	
	public FileSystemReply(T objContent)
	{
		this(objContent, null, null, null);
	}
	
	public FileSystemReply()
	{}
	
}
