package edu.mit.csail.aeolus.filesystem.tests;

import java.io.IOException;

import junit.framework.Assert;

import org.junit.After;
import org.junit.Before;
import org.junit.Test;

import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.filesystem.FileSystemClient;
import edu.mit.csail.aeolus.filesystem.FileSystemManager;
import edu.mit.csail.aeolus.infoflow.Label;
import edu.mit.csail.aeolus.runtime.RuntimeConfig;


public class TwoClientsTest {
	
	private String fsHost;

	@Before
	public void config(){
		RuntimeConfig c = RuntimeConfig.get();
		c.setFsHostName("localhost");
		c.setFsPort(2020);
		c.setEnableFSLogging(false);
		c.setEnableLogging(false);
		c.setEnableLogShipment(false);
		c.setFS_enableLogShipment(false);
		c.finalize();
		fsHost = c.getFsHostName();
	}
	
	@After
	public void shutdownRMI() throws InterruptedException{
		Thread.sleep(1000);
	}
	
	@Test
	public void testDifferentFiles() throws AeolusException, IOException, InterruptedException
	{
		FileSystemManager fs = new FileSystemManager();
		fs.start();
		Thread.sleep(100);
		
		Label empty = new Label();
//	
//		// Client 1
//		
//		FileSystemClient fsClient = new FileSystemClient(FSConfig.fsHostName);
//		fsClient.register();
//		
//		fsClient.createFile("\\a", empty, empty, empty, empty, new EventID("1"));
//		
//		byte[] content = new String("hello").getBytes();
//		fsClient.writeFile("\\a", content, empty, empty, new EventID("2"));
//		// get the file into the cache
//		fsClient.readFile("\\a", content, empty, empty, new EventID("3"));
//		
//		// reads should not miss
//		for(int i = 0; i < 100; i++)
//		{
//			fsClient.readFile("\\a", content, empty, empty, new EventID("3"));
//		}
//		Assert.assertTrue(fsClient.getCacheStats() == 1);
//		
//		fsClient.removeFile("\\a", empty, empty, new EventID("4"));

		
		// Client 2
		
		FileSystemClient fsClient = new FileSystemClient(fsHost);
		fsClient.register();
		
		fsClient.createFile("\\b", empty, empty, empty, empty, new EventID("1"));
		
		byte[] content = new String("a").getBytes();
		fsClient.writeFile("\\b", content, false, empty, empty, new EventID("2"));
		// get the file into the cache
		
		byte[] readContent = new byte[10];
		
		fsClient.readFile("\\b", readContent, empty, empty, new EventID("3"));
		
		// reads should not miss
		for(int i = 0; i < 1000; i++)
		{
			fsClient.writeFile("\\b", content, false, empty, empty, new EventID("3"));
		}
		
		fsClient.delete("\\b", empty, empty, new EventID("4"));

		Thread.sleep(5000);
		
		fsClient.shutdown();
		//fs.shutdown();
		
	}

}
