package edu.mit.csail.aeolus.infoflow;

import java.util.HashMap;
import java.util.Map;


/**
 * Structure for holding Closure ID and data in runtime memory.
 * 
 * @rewrite blanks
 */
public class ClosureMap 
{
	private Map<ClosureID, ClosureMapData> mapping;
	
	public ClosureMap()
	{
		mapping = new HashMap<ClosureID, ClosureMapData>();
	}
	
    public void addMapping(ClosureID cid, String key, PrincipalID pid)
    {
    	if (mapping.containsKey(cid))
        	return;

        ClosureMapData codeRun = new ClosureMapData(key, pid);
        mapping.put(cid, codeRun);
    }

    public void removeMapping(ClosureID cid)
    {
    	mapping.remove(cid);
    }

    public ClosureMapData getMapping(ClosureID cid)
    {
    	return mapping.get(cid);
    }
}
