package edu.mit.csail.aeolus.infoflow;

import java.io.Serializable;

public final class TagID implements Comparable<TagID>, Serializable {

	private static final long serialVersionUID = 160012254541891702L;

	public static final int DEFAULT_PARENT_ID = 0;
	
	private final int tid, parent;

	public TagID(int tid) {
		this.tid = tid;
		this.parent = DEFAULT_PARENT_ID;
	}

	public TagID(int tid, int parent) {
		this.tid = tid;
		this.parent = parent;
	}

	public int getValue() {
		return this.tid;
	}

	public int getParent() {
		return this.parent;
	}

	public int compareTo(TagID t) {
		if (t.getValue() == this.getValue()) {
			return 0;
		} else if (t.getValue() < this.getValue()) {
			return 1;
		} else {
			return -1;
		}
	}

	public boolean equals(Object o) {
		if (o == null) {
			return false;
		}
		if (o instanceof TagID) {
			return (((TagID) o).getValue() == this.getValue());
		} else {
			return false;
		}
	}

	public int hashCode() {
		return tid;
	}

	public String toString() {
		return "" + tid;
	}

	public TagID clone() {
		return new TagID(this.tid, this.parent);
	}

}
