package edu.mit.csail.aeolus.io;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.InetAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.SocketException;
import java.nio.channels.SocketChannel;

import edu.mit.csail.aeolus.infoflow.Label;

public class AeolusSocket extends Socket {
	private Socket wrapped;
	protected AeolusSocket(Socket s){
		wrapped = s;
	}
	@Override
	public void bind(SocketAddress bindpoint) throws IOException {
		wrapped.bind(bindpoint);
	}
	@Override
	public synchronized void close() throws IOException {
		wrapped.close();
	}
	@Override
	public void connect(SocketAddress endpoint, int timeout) throws IOException {
		wrapped.connect(endpoint, timeout);
	}
	@Override
	public void connect(SocketAddress endpoint) throws IOException {
		wrapped.connect(endpoint);
	}
	@Override
	public SocketChannel getChannel() {
		return wrapped.getChannel();
	}
	@Override
	public InetAddress getInetAddress() {
		return wrapped.getInetAddress();
	}
	@Override
	public InputStream getInputStream() throws IOException {
		return new CheckedInputStream(wrapped.getInputStream(), new Label(), new Label());
	}
	@Override
	public boolean getKeepAlive() throws SocketException {
		return wrapped.getKeepAlive();
	}
	@Override
	public InetAddress getLocalAddress() {
		return wrapped.getLocalAddress();
	}
	@Override
	public int getLocalPort() {
		return wrapped.getLocalPort();
	}
	@Override
	public SocketAddress getLocalSocketAddress() {
		return wrapped.getLocalSocketAddress();
	}
	@Override
	public boolean getOOBInline() throws SocketException {
		return wrapped.getOOBInline();
	}
	@Override
	public OutputStream getOutputStream() throws IOException {
		return new CheckedOutputStream(wrapped.getOutputStream(), new Label(), new Label());
	}
	@Override
	public int getPort() {
		return wrapped.getPort();
	}
	@Override
	public synchronized int getReceiveBufferSize() throws SocketException {
		return wrapped.getReceiveBufferSize();
	}
	@Override
	public SocketAddress getRemoteSocketAddress() {
		return wrapped.getRemoteSocketAddress();
	}
	@Override
	public boolean getReuseAddress() throws SocketException {
		return wrapped.getReuseAddress();
	}
	@Override
	public synchronized int getSendBufferSize() throws SocketException {
		// TODO Auto-generated method stub
		return wrapped.getSendBufferSize();
	}
	@Override
	public int getSoLinger() throws SocketException {
		// TODO Auto-generated method stub
		return wrapped.getSoLinger();
	}
	@Override
	public synchronized int getSoTimeout() throws SocketException {
		// TODO Auto-generated method stub
		return wrapped.getSoTimeout();
	}
	@Override
	public boolean getTcpNoDelay() throws SocketException {
		// TODO Auto-generated method stub
		return wrapped.getTcpNoDelay();
	}
	@Override
	public int getTrafficClass() throws SocketException {
		// TODO Auto-generated method stub
		return wrapped.getTrafficClass();
	}
	@Override
	public boolean isBound() {
		// TODO Auto-generated method stub
		return wrapped.isBound();
	}
	@Override
	public boolean isClosed() {
		// TODO Auto-generated method stub
		return wrapped.isClosed();
	}
	@Override
	public boolean isConnected() {
		// TODO Auto-generated method stub
		return wrapped.isConnected();
	}
	@Override
	public boolean isInputShutdown() {
		// TODO Auto-generated method stub
		return wrapped.isInputShutdown();
	}
	@Override
	public boolean isOutputShutdown() {
		// TODO Auto-generated method stub
		return wrapped.isOutputShutdown();
	}
	@Override
	public void sendUrgentData(int data) throws IOException {
		// TODO Auto-generated method stub
		wrapped.sendUrgentData(data);
	}
	@Override
	public void setKeepAlive(boolean on) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setKeepAlive(on);
	}
	@Override
	public void setOOBInline(boolean on) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setOOBInline(on);
	}
	// @Override
	// public void setPerformancePreferences(int connectionTime, int latency,
	// 		int bandwidth) {
	// 	// TODO Auto-generated method stub
	// 	wrapped.setPerformancePreferences(connectionTime, latency, bandwidth);
	// }
	@Override
	public synchronized void setReceiveBufferSize(int size)
			throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setReceiveBufferSize(size);
	}
	@Override
	public void setReuseAddress(boolean on) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setReuseAddress(on);
	}
	@Override
	public synchronized void setSendBufferSize(int size) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setSendBufferSize(size);
	}
	@Override
	public void setSoLinger(boolean on, int linger) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setSoLinger(on, linger);
	}
	@Override
	public synchronized void setSoTimeout(int timeout) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setSoTimeout(timeout);
	}
	@Override
	public void setTcpNoDelay(boolean on) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setTcpNoDelay(on);
	}
	@Override
	public void setTrafficClass(int tc) throws SocketException {
		// TODO Auto-generated method stub
		wrapped.setTrafficClass(tc);
	}
	@Override
	public void shutdownInput() throws IOException {
		// TODO Auto-generated method stub
		wrapped.shutdownInput();
	}
	@Override
	public void shutdownOutput() throws IOException {
		wrapped.shutdownOutput();
	}
	@Override
	public String toString() {
		return wrapped.toString();
	}
	
}
