package edu.mit.csail.aeolus.io;

import java.io.IOException;
import java.io.OutputStream;

import edu.mit.csail.aeolus.api.AeolusUserInternal;
import edu.mit.csail.aeolus.infoflow.InfoFlowState;
import edu.mit.csail.aeolus.infoflow.Label;

public class CheckedOutputStream extends OutputStream{
	private OutputStream wrappedStream;
	private Label integrity, secrecy;
	
	public CheckedOutputStream(OutputStream wrappedStream, Label integrity,
			Label secrecy) {
		this.wrappedStream = wrappedStream;
		this.integrity = integrity;
		this.secrecy = secrecy;
	}

	@Override
	public void write(int arg0) throws IOException {
		boolean valid;
		try{
			try{
				AeolusUserInternal u = new AeolusUserInternal();
				InfoFlowState ifs = u.getInfoFlowState();
				valid = integrity.isSubsetOf(ifs.ILabel) && ifs.SLabel.isSubsetOf(secrecy);
			} catch (Exception e) {
				throw new IOException(e.getMessage());
			}
		} catch (Exception e) {
			throw new IOException(e.getMessage());
		}
		if(!valid)
			throw new IOException("Invalid process labels for reading from inputstream.");
		wrappedStream.write(arg0);
	}

}
