package edu.mit.csail.aeolus.profiling;

import edu.mit.csail.aeolus.utilities.CanalTimer;
import edu.mit.csail.aeolus.utilities.StopWatch;

public class CacheManagerProfile {
	private Double elapsedProfileOnTime = 0.0;
	private int numAuthRequests = 0;
	private int numAuthYes = 0;
	private int numRequestOnC1 = 0;
	private int numRequestOnC2 = 0;
	private int numHitOnC1 = 0;
	private int numHitOnC2 = 0;

	// Streaming Stats
	private Double streamProcessingTime = 0.0;
	private int streamNumMessages = 0;

	// Timers
	private CanalTimer timer;
	private CanalTimer streamTimer;

	public CacheManagerProfile(){
		
		timer = new StopWatch();
		streamTimer = new StopWatch();
	}
	
	public void startTimer(){
		timer.start();
	}
	public void stopTimer(){
		timer.stop();
		elapsedProfileOnTime += timer.getDuration();
	}
	public void countAuthReq() {
		numAuthRequests++;
	}	
	public void countStreamMsg() {
		streamNumMessages++;
	}
	public void addC1Check() {
		numRequestOnC1++;
	}
	public void addC2Check() {
		numRequestOnC2++;
	}
	public void addHasAuth() {
		// TODO Auto-generated method stub
		numAuthYes++;
	}
	public void addC1Hit() {
		// TODO Auto-generated method stub
		numHitOnC1++;
	}
	public void addC2Hit() {
		// TODO Auto-generated method stub
		numHitOnC2++;
	}
	public void startStream() {
		// TODO Auto-generated method stub
		streamTimer.start();
	}
	public void stopStream() {
		streamTimer.stop();
		streamProcessingTime += streamTimer.getDuration();
	}
}