package edu.mit.csail.aeolus.rpc;
import java.io.Serializable;
import java.lang.reflect.InvocationTargetException;
import java.rmi.Remote;
import java.rmi.RemoteException;

import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.exceptions.AeolusException;
import edu.mit.csail.aeolus.exceptions.AuthorityException;
import edu.mit.csail.aeolus.exceptions.RpcException;
import edu.mit.csail.aeolus.infoflow.PlatformInstanceID;
import edu.mit.csail.aeolus.infoflow.PrincipalID;


public interface AeolusRpcInterface extends Remote {

	@SuppressWarnings("unchecked")
	public RpcReply invokeRemoteMethod(final String className, final String methodName, final Class[] parameterTypes, 
										final Serializable[] parameterValues,
										final RpcToken token) throws RemoteException, RpcException;
	
	public int testCall(int a) throws RemoteException;
	
	public RpcReply launchRemotePI(PrincipalID callerPid, String appName, String appParams, PrincipalID pid, EventID opEid, RpcToken rpcToken) 
	throws RemoteException, RpcException, InvocationTargetException, ClassNotFoundException, NoSuchMethodException, AeolusException, RpcException;
	
	public void shutdownRemotePI(PlatformInstanceID platformInstanceID, PrincipalID callerPid, boolean shutdownImmediately, EventID opEid) 
	throws RemoteException, RpcException, AuthorityException;

}
