package edu.mit.csail.aeolus.rpc;

/**
 * Web methods support
 * 
 * - allow user applications to invoke methods on other compute nodes in the system
 * 
 * Must ensure that the web method is executed with the appropriate principal and process labels
 * to preserve information flow properties; therefore, need to
 * - communicate information flow state and mediate the web method call between client and server compute nodes
 * -> will tap into the messaging framework and web method runtime to take advantage of programming hooks
 * and callbacks
 * 
 * SOAP is an XML-based protocol that lets applications exchange information over internet
 * At the remote machine, the HTTP server passes the SOAP message to the language runtime, 
 * which de-serializes the message and invokes
 * the web method
 * 
 * Aeolus taps into the programming hooks in the serialization and deserialization of SOAP messages
 * at the client and the server to inject and retrieve information flow state for the call and return
 * Also taps into the dispatching logic for web method invocations on the server-side to control  their 
 * invocations
 * 
 * From applications' perspective, a web service is a remote object with a set of web methods
 * 
 * 
 * 
 * It is the JAX-WS runtime system that converts the API calls and responses to and from SOAP messages. 
 * 
 * SOAPHandlers provide access to the entire SOAP envelope--header and body. SAAJ is used to manipulate 
 * the message's contents. A SOAPHandler is the main example of a protocol handler, 
 * which allows access to information specific to the protocol (SOAP) being used
 * 
 * @author viq
 *
 */
public class MigrationHeader {

}
