package edu.mit.csail.aeolus.rpc;

import java.io.Serializable;

import edu.mit.csail.aeolus.api.SystemNodeID;
import edu.mit.csail.aeolus.auditing.EventID;
import edu.mit.csail.aeolus.infoflow.InfoFlowState;

/**
 * Aeolus information passed with rpc calls
 * 
 * Consists of info flow state, predecessor, and caller's PI id
 * 
 * @author viq
 *
 */
public class RpcToken implements Serializable{

	private static final long serialVersionUID = -1907706396827407482L;

	public final EventID predecessorEventId;
	public final InfoFlowState state;
	public final int invalidationNumber;
	public final SystemNodeID callerNodeID;
	
	public RpcToken (InfoFlowState callerState, EventID predecessorEid, int invNumber, SystemNodeID callerNodeID){
		this.state = callerState;
		this.predecessorEventId = predecessorEid;
		this.invalidationNumber = invNumber;
		this.callerNodeID = callerNodeID;
	}
}
