package edu.mit.csail.aeolus.runtime;

/**
 * An AppDomain is a Thread object that is also associated
 * with a ProxyObject
 *
 * @author viq
 * 
 */
public class UserDomain extends Thread{

	protected UserProxy po;
	
	/**
	 * Constructor
	 * @param po - ProxyObject associated with this AppDomain
	 * @param r - factory Thread constructor Runnable 
	 */
	public UserDomain(Runnable r)
	{
		super(r);
	}
	
	/**
	 * @param pObj - ProxyObject associated with this AppDomain
	 */
	public void setProxyObject(UserProxy pObj)
	{
		this.po = pObj;
	}
	
	public UserProxy getProxyObject()
	{
		return this.po;
	}
}


