package edu.mit.csail.aeolus.stream.client.api;

import java.rmi.Remote;
import java.rmi.RemoteException;

import edu.mit.csail.aeolus.stream.client.InvalidationPacket;

public interface IStreamClient extends Remote{
    // InterfaceStreamClient
    // - This is an 'alert' or reply interfaces from the stream server or stream distribution network.
    boolean isAlive() throws RemoteException;

    // Initialize()
    // - Call by Authority Client during the creation of channels and cache objects
    // - Creates IPC connection to cacheObjMgr
//    void initialize() throws RemoteException;

    // HandleStreamMessage
    // - Periodic stream messages that come from the server.
    // - In practice, these are batched and streamed at intervals.
    // - usually it comes with <changes since last snapshot> <new snapshot name>

    void handleInvalidationPacket(InvalidationPacket ip) throws RemoteException;
}
