package edu.mit.csail.aeolus.utilities;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.net.URL;
import java.net.URLClassLoader;
import java.util.jar.JarEntry;
import java.util.jar.JarInputStream;

/**
 * Dynamically loads classes from a jar file 
 * 
 * viq
 *
 */
public class JarLoader {
	
	public void loadJar(String jarName) throws FileNotFoundException, IOException
	{
		URL jarURL = new URL("file", null, jarName);
		
		URLClassLoader loader = new URLClassLoader(new URL[]{jarURL});
		
		JarInputStream jis = new JarInputStream(new FileInputStream(jarName));
		JarEntry entry = jis.getNextJarEntry();
		
		while(entry != null)
		{
			String name = entry.getName();
			if(name.endsWith(".class"))
			{
				name = name.substring(0, name.length() - 6);
				name = name.replace('/', '.');
				
				try 
				{
					loader.loadClass(name);
				} 
				catch (ClassNotFoundException e) 
				{
					// couldn't load this class...
				}
			}
			
			entry = jis.getNextJarEntry();
		}
		
	}
}
