import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.table.TableColumn;

import org.jfree.ui.RefineryUtilities;
import org.postgresql.ds.PGConnectionPoolDataSource;


public class RunDemo {
	private static PGConnectionPoolDataSource cpds;
	private static String DB_Name = "AeolusAuthority";

	public static int ACTIVITY_BUCKET_SIZE = 60; //seconds for AuditUserAccountActivity
	public static String[] users = Users.stringValues(); //list of users to run test on, for AuditUserAccountActivity
	
	public static void main(String[] args) throws SQLException{
		connect();
//		auditUserDataPrivacy();
//		System.out.println("next query");
//		auditBankCredentials();
		setUpGUI();
	}
	public static ResultSet auditUserDataPrivacy() throws SQLException{
		Connection c = cpds.getConnection();
		String x = "op_name, secrecy, integrity, event_counter, running_principal, tags_modified, virtual_node_id, method_name, timestamp";
		String y = "secrecy, integrity, running_principal, tags_modified, virtual_node_id, method_name, timestamp";
		String z = "select * from events as e where tags_modified in (select app_arg from events where op_name=1000 and e.running_principal<>running_principal and e.running_principal<>4) and op_name=89";
		String f = "select " + y + " from (select * from (select distinct on (tags_modified) " + x + " from " + z + " and op_name=89 ) as e order by e.event_counter) as f;";
		String createAttacks = "create or replace view attacks as select secrecy, integrity, running_principal, tags_modified, virtual_node_id, method_name, timestamp from (select * from events as e where tags_modified in (select app_arg from events where op_name=1000 and e.running_principal<>running_principal and e.running_principal<>4) and op_name=89) as x";
		String createSignups = "create or replace view signups (op_name, running_principal, app_name, app_arg, virtual_node_id, method_name, timestamp) as select op_name, running_principal, app_name, app_arg, virtual_node_id, method_name, timestamp from events where op_name=1000";
		String createAttacks2 = "create or replace view attacks2 (secrecy, integrity, attacker_pid, attacker, tags_modified, virtual_node_id, method_name, timestamp) as select attacks.secrecy, attacks.integrity, attacks.running_principal, signups.app_name, attacks.tags_modified, attacks.virtual_node_id, attacks.method_name, attacks.timestamp from attacks inner join signups on attacks.running_principal=signups.running_principal";
		String createAttacksWithNames = "create or replace view attacksWithNames (secrecy, integrity, attacker_pid, attacker, victim_pid, victim, tags_modified, virtual_node_id, method_name, timestamp) as select attacks2.secrecy, attacks2.integrity, attacks2.attacker_pid, attacks2.attacker, signups.running_principal, signups.app_name, attacks2.tags_modified, attacks2.virtual_node_id, attacks2.method_name, attacks2.timestamp from attacks2 inner join signups on attacks2.tags_modified=signups.app_arg;";
		
		Statement s = c.createStatement();
		s.addBatch(createAttacks);
		s.addBatch(createSignups);
		s.addBatch(createAttacks2);
		s.addBatch(createAttacksWithNames);
		s.executeBatch();
		ResultSet results = s.executeQuery("select * from attackswithnames");
		
		String drop1 = "drop view attackswithnames";
		String drop2 = "drop view attacks2";
		String drop3 = "drop view signups";
		String drop4 = "drop view attacks";
		
//		s.addBatch(drop1);
//		s.addBatch(drop2);
//		s.addBatch(drop3);
//		s.addBatch(drop4);
//		s.executeBatch();
		
		return results;
//		ResultSetMetaData meta = results.getMetaData();
//		StringBuffer rows = new StringBuffer();
//		while (results.next()){
//			for (int i = 1; i <= meta.getColumnCount(); i ++){
//				rows.append(results.getString(i));
//				rows.append("<br>");
//			}
//		}
//		c.close();
//		return rows.toString();
	}
	
	public static ResultSet auditBankCredentials() throws SQLException{
		Connection c = cpds.getConnection();
		PreparedStatement s = c.prepareStatement("select * from events where (tags_modified='[5]' or tags_modified ='[6]') and op_name=89;");
		ResultSet results = s.executeQuery();
		return results;
//		ResultSetMetaData meta = results.getMetaData();
//		StringBuffer rows = new StringBuffer();
//		while (results.next()){
//			for (int i = 1; i <= meta.getColumnCount(); i ++){
//				rows.append(results.getString(i));
//				rows.append("<br>");
//			}
//		}
//		c.close();
//		return rows.toString();
	}
	
	public static int[] auditUserAccountActivity(String user) {
		try{
			Connection c = cpds.getConnection();
			String q = "select count(*) from events where tags_modified in (select app_arg from events where app_name='" + user + "') group by (to_timestamp(((extract (epoch from events.timestamp)/" + ACTIVITY_BUCKET_SIZE+")::int)*"+ACTIVITY_BUCKET_SIZE+"))";
			PreparedStatement s = c.prepareStatement(q);
			ResultSet r = s.executeQuery();
			ArrayList<Integer> list = new ArrayList<Integer>();
			while (r.next()){
				//String q = "select count(*) from events where timestamp > '" + running_min + "' and timestamp < '" + running_max + "' and tags_modified in (select app_arg from events where app_name='Rose')";
				list.add(r.getInt(1));
			}
			int[] hist = new int[list.size()];
			for(int i =0; i<list.size(); i++)
				hist[i] = list.get(i);
			return hist;
		}catch(SQLException e){
			e.printStackTrace();
		}
		return null;
	}
	
//	public Timestamp[] getUserLoginDates
	
	public static void connect(){
		cpds = new PGConnectionPoolDataSource();
		Logger.getLogger("").setLevel(Level.OFF);
		cpds.setDatabaseName(DB_Name);
		cpds.setPortNumber(5432);
		cpds.setServerName("localhost");
		cpds.setDefaultAutoCommit(true);
	}
	public static void setUpGUI(){
		JFrame p1 = new JFrame();
		JPanel action1 = new JPanel(new BorderLayout(10,2));
		JPanel action2 = new JPanel(new BorderLayout(10,2));
		JPanel action3 = new JPanel(new BorderLayout(10,2));
		JPanel action4 = new JPanel(new BorderLayout(10,2));
		action1.setBorder(BorderFactory.createLineBorder(Color.black));
		action2.setBorder(BorderFactory.createLineBorder(Color.black));
		action3.setBorder(BorderFactory.createLineBorder(Color.black));
		action4.setBorder(BorderFactory.createLineBorder(Color.black));
		
		JPanel text1 = new JPanel();
		text1.setLayout(new BoxLayout(text1, BoxLayout.PAGE_AXIS));
		JPanel text2 = new JPanel(new BorderLayout(0,5));
		text2.setLayout(new BoxLayout(text2, BoxLayout.PAGE_AXIS));
		JPanel text3 = new JPanel(new BorderLayout(0,5));
		text3.setLayout(new BoxLayout(text3, BoxLayout.PAGE_AXIS));
		JPanel text4 = new JPanel(new BorderLayout(0,5));
		text4.setLayout(new BoxLayout(text4, BoxLayout.PAGE_AXIS));
		
		JPanel bw1 = new JPanel(new BorderLayout());
		JPanel bw2 = new JPanel(new BorderLayout());
		JPanel bw3 = new JPanel(new BorderLayout());
		JPanel bw4 = new JPanel(new BorderLayout());
		
		JLabel title1 = new JLabel(html("<b>Audit User Data Privacy</b>"));
		JLabel title2 = new JLabel(html("<b>Audity Bank Credentials</b>"));
		JLabel title3 = new JLabel(html("<b>Audit User Account Activity</b>"));
		JLabel title4 = new JLabel(html("<b>Account Compromise Damage Assessment</b>"));
		Font newLabelFont = new Font(title1.getFont().getName(), Font.BOLD, title1.getFont().getSize());  
		title1.setFont(newLabelFont);
		title2.setFont(newLabelFont);
		title3.setFont(newLabelFont);
		title4.setFont(newLabelFont);
		JLabel desc1 = new JLabel(html("This query determines whether any user's data has been <br> declassifed by any other user"));
		JLabel desc2 = new JLabel(html("This query verifies that only banks ever declassify user account <br> credentials"));
		JLabel desc3 = new JLabel(html("Display a histogram of a particular user's account activity over time <br> to look for suspicious behavior"));
		JLabel desc4 = new JLabel(html("Examin the impact of all of user's account activity with a given <br> date range. This is useful for damage assessment if known <br> that the user's account was compromised during that period"));
		JButton b1 = new JButton("Run");
		b1.addActionListener(new AUDP());
		JButton b2 = new JButton("Run");
		JButton b3 = new JButton("Run");
		b3.addActionListener(new AUAA());
		JButton b4 = new JButton("Run");
		bw1.add(b1, BorderLayout.NORTH);
		bw2.add(b2, BorderLayout.NORTH);
		bw3.add(b3, BorderLayout.NORTH);
		bw4.add(b4, BorderLayout.NORTH);
		JPanel panel = new JPanel();
		panel.setLayout(new BoxLayout(panel, BoxLayout.PAGE_AXIS));
		action1.add(bw1, BorderLayout.WEST);
		text1.add(title1);
		text1.add(desc1);
		action1.add(text1, BorderLayout.CENTER);
		action2.add(bw2, BorderLayout.WEST);
		text2.add(title2);
		text2.add(desc2);
		action2.add(text2, BorderLayout.CENTER);
		action3.add(bw3, BorderLayout.WEST);
		text3.add(title3);
		text3.add(desc3);
		action3.add(text3, BorderLayout.CENTER);
		action4.add(bw4, BorderLayout.WEST);
		text4.add(title4);
		text4.add(desc4);
		action4.add(text4, BorderLayout.CENTER);
		panel.add(action1);
		panel.add(action2);
		panel.add(action3);
		panel.add(action4);
		p1.setContentPane(panel);
		p1.pack();
		p1.paintComponents(p1.getGraphics());
		p1.setVisible(true);
	}
	
	public static String html(String x){
		return "<html>" + x + "</html>";
	}
}

class AUDP implements ActionListener{

	@Override
	public void actionPerformed(ActionEvent arg0) {
		JFrame frame = new JFrame("results");
		JPanel panel = new JPanel(new GridLayout(1,0));
		ResultSetTable x = null;
		try {
			x = new ResultSetTable(RunDemo.auditUserDataPrivacy());
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		TableColumn column = null;
		for (int i = 0; i < 5; i++) {
		    column = x.getColumnModel().getColumn(i);
	        column.setPreferredWidth(100);
		}
//		JLabel result = new JLabel(RunDemo.html(x));
        x.setPreferredScrollableViewportSize(new Dimension(1000, 500));
        x.setFillsViewportHeight(true);

        JScrollPane scroll = new JScrollPane(x);
		panel.add(scroll);
		frame.add(panel);
		frame.pack();
		frame.setVisible(true);
	}
	
}

class AUAA implements ActionListener{

	@Override
	public void actionPerformed(ActionEvent arg0) {
//	    JFrame f = new JFrame();
//	    f.setSize(400, 300);
	    
        
        //input which users you would like to audit
		String[] series = RunDemo.users;
		int[][] values = new int[series.length][];
		
		int max = 0;
		
		for (int i = 0; i<series.length; i++){
			values[i] = RunDemo.auditUserAccountActivity(series[i]);
			if (values[i].length>max)
				max = values[i].length;
		}
		String[] categories = new String[max];
		for (int i = 0; i<categories.length; i++){
			categories[i] = (int)((i+0.5)*RunDemo.ACTIVITY_BUCKET_SIZE) +"";
		}
		String title = "Audit User Account Activity";
		String category = "Requests every " + RunDemo.ACTIVITY_BUCKET_SIZE + " seconds";
		String value = "Number of requests";
		
		BarChartDemo1 demo = new BarChartDemo1(title, category, value, values, categories, series);
        demo.pack();
        RefineryUtilities.centerFrameOnScreen(demo);
        demo.setVisible(true);
        
//	    f.getContentPane().add(new ChartPanel(audit, names, "User Activity for Dina"));
//	 
//	    WindowListener wndCloser = new WindowAdapter() {
//	      public void windowClosing(WindowEvent e) {
//	        System.exit(0);
//	      }
//	    };
//	    f.addWindowListener(wndCloser);
//	    f.setVisible(true);
	}
	
}
